VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsManageLogin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mvarLatestPassword As String
Private mvarLatestRememberPassword As Integer
Private mvarLatestLogin As Long
Private mvarAdminLogin As Boolean '

Public Property Let AdminLogin(ByVal vData As Boolean)
    mvarAdminLogin = vData
End Property

Public Property Get AdminLogin() As Boolean
    AdminLogin = mvarAdminLogin
End Property

Public Property Let LatestLogin(ByVal vData As Long)
    mvarLatestLogin = vData
End Property

Public Property Get LatestLogin() As Long
    LatestLogin = mvarLatestLogin
End Property

Public Property Let LatestRememberPassword(ByVal vData As Integer)
    mvarLatestRememberPassword = vData
End Property

Public Property Get LatestRememberPassword() As Integer
    LatestRememberPassword = mvarLatestRememberPassword
End Property

Public Property Let LatestPassword(ByVal vData As String)
    mvarLatestPassword = vData
End Property

Public Property Get LatestPassword() As String
    LatestPassword = mvarLatestPassword
End Property

Public Sub SubmitPassword(sourceForm As Form)
    'check for correct password
    Dim newPassword As String
    Dim newCustID As Long
    
    newPassword = sourceForm.txtPassword.Text
    
    newCustID = sourceForm.lstUserName.ItemData(sourceForm.lstUserName.ListIndex)
    
    LatestLogin = newCustID
    LatestPassword = sourceForm.txtPassword.Text
    LatestRememberPassword = sourceForm.chkPassword.Value
    If newCustID = coAdmin Then AdminLogin = True
    sourceForm.Hide
End Sub

Public Sub formActivate(targetForm As Form)
    Dim rsUser As Recordset
    Dim counter As Long
    Dim indexHolder As Long
    
    indexHolder = targetForm.lstUserName.ListIndex
    
    targetForm.lstUserName.Clear
    
    Set rsUser = gdbMain.OpenRecordset("SELECT CUSTOMERS.* FROM CUSTOMERS", dbOpenSnapshot)
    If rsUser.EOF = False Then ' existing customers
        
        Do While rsUser.EOF = False
            targetForm.lstUserName.AddItem Trim(rsUser.Fields("NAME"))
            targetForm.lstUserName.ItemData(targetForm.lstUserName.NewIndex) = Trim(rsUser.Fields("CUSTID"))
            rsUser.MoveNext
        Loop
        
        ' previously selected user
        If indexHolder < 0 Then
            targetForm.lstUserName.ListIndex = 0
        Else
            ' reset to previous selection if there are still that many customers
            If indexHolder < targetForm.lstUserName.ListCount Then targetForm.lstUserName.ListIndex = indexHolder
        End If
    End If
    
    targetForm.chkPassword.Value = LatestRememberPassword
    If targetForm.chkPassword.Value = vbUnchecked Then
        targetForm.txtPassword.Text = ""
    Else
        targetForm.txtPassword.Text = LatestPassword
    End If
End Sub

Private Sub Class_Initialize()
    LatestLogin = coNoLogin
    LatestRememberPassword = vbUnchecked
End Sub
