VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "OrderManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3832007F00BE"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"Manager"
Option Explicit

'##ModelId=386BECCE0295
Implements IMaintADO

'##ModelId=3841B8C9033F
Implements IViewADO

Implements IPayment

'##ModelId=38432A6D01D1
Private customerID As Integer

'##ModelId=38432A8300F6
Private state As Integer

'##ModelId=38432A9600E0
Private ON_ORDER_STATE As Integer

'##ModelId=38432AD80008
Private BACK_ORDERED_STATE As Integer

'##ModelId=38432AF00338
Private SHIPPED_STATE As Integer

'##ModelId=38A1C249007F
Private Property Get IViewADO_ClassDebugID() As Variant
    On Error GoTo IViewADO_ClassDebugIDErr

    '## Your code goes here ...

    Exit Property
IViewADO_ClassDebugIDErr:
    Call RaiseError(MyUnhandledError, "IViewADO_ClassDebugID Property")
End Property

'##ModelId=38A1C249030A
Private Property Get IMaintADO_ClassDebugID() As Variant
    On Error GoTo IMaintADO_ClassDebugIDErr

    '## Your code goes here ...

    Exit Property
IMaintADO_ClassDebugIDErr:
    Call RaiseError(MyUnhandledError, "IMaintADO_ClassDebugID Property")
End Property

'Add a CD
'##ModelId=384EECA503BF
Private Sub IMaintADO_Save(rs As Recordset)
    On Error GoTo IMaintADO_SaveErr

    '## Your code goes here ...

    Exit Sub
IMaintADO_SaveErr:
    Call RaiseError(MyUnhandledError, "IMaintADO_Save Sub")
End Sub

'Remove a CD
'##ModelId=384EECF80256
Private Sub IMaintADO_Delete(intID As Integer)
    On Error GoTo IMaintADO_DeleteErr

    '## Your code goes here ...

    Exit Sub
IMaintADO_DeleteErr:
    Call RaiseError(MyUnhandledError, "IMaintADO_Delete Sub")
End Sub

'##ModelId=384EEDC503D7
Private Function GetEmptyRecordset() As Recordset
    On Error GoTo GetEmptyRecordsetErr

    '## Your code goes here ...

    Exit Function
GetEmptyRecordsetErr:
    Call RaiseError(MyUnhandledError, "GetEmptyRecordset Function")
End Function

'Get an order by the Order ID
'##ModelId=385183260002
Private Function IViewADO_GetByID(intID As Integer) As Recordset
    On Error GoTo IViewADO_GetByIDErr

        Dim theOrderFetcher As DataServices.OrderFetcher
        Set theOrderFetcher = CreateObject("DataServices.OrderFetcher")
        Set IViewADO_GetByID = theOrderFetcher.GetByID(intID)

    Exit Function
IViewADO_GetByIDErr:
    Call RaiseError(MyUnhandledError, "IViewADO_GetByID Function")
End Function

'Add a CD
'##ModelId=386BE25A014C
Private Sub SaveRS(rs As Recordset)
    On Error GoTo SaveRSErr

    '## Your code goes here ...

    Exit Sub
SaveRSErr:
    Call RaiseError(MyUnhandledError, "SaveRS Sub")
End Sub

'Remove a CD
'##ModelId=386BE2C102E5
Private Sub Delete(intID As Integer)
    On Error GoTo DeleteErr

    '## Your code goes here ...

    Exit Sub
DeleteErr:
    Call RaiseError(MyUnhandledError, "Delete Sub")
End Sub

'##ModelId=386BEB6E03D9
Private Function GetByIDAsRS(intID As Integer) As Recordset
    On Error GoTo GetByIDAsRSErr

    '## Your code goes here ...

    Exit Function
GetByIDAsRSErr:
    Call RaiseError(MyUnhandledError, "GetByIDAsRS Function")
End Function

'##ModelId=38A0560F01C4
Private Function IViewADO_GetList() As Recordset
    On Error GoTo IViewADO_GetListErr

    
    
    Exit Function
IViewADO_GetListErr:
    Call RaiseError(MyUnhandledError, "IViewADO_GetList Function")
End Function

'##ModelId=38A0560F026E
Private Function IViewADO_Search(strCDSearchString As String, intCDSearchCriteria As Integer) As Recordset
    On Error GoTo IViewADO_SearchErr

    '## Your code goes here ...

    Exit Function
IViewADO_SearchErr:
    Call RaiseError(MyUnhandledError, "IViewADO_Search Function")
End Function

Public Function IPayment_confirmOrder(customerID As Integer, ordernumber As Integer) As Boolean
    On Error GoTo IPayment_confirmOrderErr

        Dim theOrderModifier As DataServices.OrderModifier
        Set theOrderModifier = CreateObject("DataServices.OrderModifier")
        IPayment_confirmOrder = theOrderModifier.confirm(customerID, ordernumber)
        
    Exit Function
IPayment_confirmOrderErr:
    
    If Err.number = 800 Then
        Err.Raise 800, "Source", "Description"
        Exit Function
    End If
    
    If Err.description = "Invalid Order" Then
        Err.Raise 901, "Source", "Description"
        Exit Function
    End If
        
    Call RaiseError(MyUnhandledError, "IPayment_confirmOrder Function")
   
End Function

Public Function IPayment_getPaymentInfo() As Recordset
'No implementation (abstract class)
End Function


'**************************************
' New Public Function (not on any of the Interfaces) to get order status using the PandaEx WebService
Public Function GetStatus(ordernumber As Integer) As String
    On Error GoTo GetStatusErr
    
        Dim m_oRopeProxy 'the ROPE proxy object which abstracts SOAP
        Dim bRetVal 'the return value from LoadServiceDescription
        Dim sRetVal 'the return value from this function
    
        'has the proxy been initialized?
        If (VarType(m_oRopeProxy) = 0) Then '0 = vbEmpty
            'nope, so create it
            Set m_oRopeProxy = CreateObject("ROPE.Proxy")

            'initialize the ROPE proxy with the SDL for the web service we are calling
            bRetVal = m_oRopeProxy.LoadServicesDescription(1, "http://localhost/PandaEx/webservices/ShipmentStatus.xml")
            
            If (bRetVal = False) Then
                Err.Raise (-2147221504 Or 512), "GetShipmentStatus", "LoadServiceDescription failed"
            End If
        End If
            
        'make the remote call to get the status of the shipment
        sRetVal = m_oRopeProxy.GetShipmentStatus(CStr(ordernumber))
        
        GetStatus = sRetVal
    
    Exit Function
GetStatusErr:
    Call RaiseError(MyUnhandledError, "GetStatus Function")
End Function
'**************************************

