
import java.awt.event.ActionListener;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.util.*;

import javax.swing.table.AbstractTableModel;
import javax.swing.tree.*;
import javax.swing.event.*;

import javax.swing.*;

public class ClassicsJava extends JFrame{
	static Vector prodVector = null;
	static Product selectedProduct = new Product();
	static Customer currentCustomer = new Customer();
	Vector custList;
	String[][] oops= new String [100][100];
	JComboBox nameCombo;
	JComboBox nameComboB;
	JPasswordField passText;
	JCheckBox check;
	JComboBox creditCombo;
	JTextField cardNumberField;
	JTextField expireField;
	JTextField quantityField;
	JTextField nameField;
	JTextField streetField;
	JTextField cszField;
	JTextField phoneField;
	static boolean existing;
	float totalPriceValue;

	static JButton placeOrderButton;

	JTable existingTable;
	TableModel existModel;

	JTable orderTable;
	OrderTableModel ordModel;

	JTable custTable;
	CustTableModel custModel;

	JTable productTable;
	ProductTableModel prodModel;

	JTextArea info;
	static JLabel composerLabel;
	static JLabel compositionLabel;
	static JLabel imageLabel;

	static JLabel detComposera;
	static JLabel detComposerb;
	static JLabel detCompositiona;
	static JLabel detCompositionb;
	static JLabel detConductora;
	static JLabel detConductorb;
	static JLabel detOrchestraa;
	static JLabel detOrchestrab;
	static JLabel detPricea;
	static JLabel detPriceb;
	static JTextArea detDescriptionb;

	static Container cont;
	
	static ImageIcon splashImage;
	static JLabel splashLabel;

	JLabel totalPrice;

	JFrame logFrame1;

	JFrame logFrame2;

	JFrame orderForm;
	JFrame logFrame3;
	String adminMenuClick;
	JFrame orderStatusForm;
	JFrame clearDataForm;

	JFrame customerAdminForm;
	JFrame orderAdminForm;
	JFrame productAdminForm;

	JFrame aboutFrame;
	static JTabbedPane tabbedPane;

	public static boolean bClearCustomers ;
	public static boolean bClearOrders ;
	class MyTreeSelectionListener
	  implements TreeSelectionListener {
	public void valueChanged (TreeSelectionEvent event) {

	  TreePath path = event.getPath();
	  Object elements[] = path.getPath();

	  placeOrderButton.setEnabled( elements.length == 3 );

	int z=0;
	String a,b,c,d;
	b="";
	d="";

	while (z < prodVector.size())
		{
		a = ((Product) prodVector.elementAt(z)).getComposer();
		if (elements.length>1)
			{b = elements[1].toString();}
		c = ((Product) prodVector.elementAt(z)).getComposition();

		if (elements.length>2)
			{d=elements[2].toString();}
		if (a.equals(b))
			{
			if (elements.length>1)
			{
			if (c==d)
				{
				imageLabel.setIcon(((Product) prodVector.elementAt(z)).getAlbumImage());
				composerLabel.setText(((Product) prodVector.elementAt(z)).getComposer());
				compositionLabel.setText(((Product) prodVector.elementAt(z)).getComposition());

				detComposerb.setText(((Product) prodVector.elementAt(z)).getComposer());


				detCompositionb.setText(((Product) prodVector.elementAt(z)).getComposition());


				detOrchestrab.setText(((Product) prodVector.elementAt(z)).getPerformer());
				detPriceb.setText("$"+((Product) prodVector.elementAt(z)).getPrice());

				selectedProduct = (Product) prodVector.elementAt(z);
			//	System.out.println("Selected :" + selectedProduct.getProdid());

				detDescriptionb.setText("");
				detDescriptionb.setText(((Product) prodVector.elementAt(z)).getDescription());
				detDescriptionb.repaint();
				break;
				}
			}
			}
		z++;
		}
		repaint();
	}
  }

class OrderActionListener implements ActionListener
		{
		public void actionPerformed (java.awt.event.ActionEvent e)
			{
			if (true)
				{
				// System.out.println("click");
//				URL codebase = getCodeBase();
				custList = DataAccess.getCustomers();
				makeOrderLogon(custList);
				}
			}

		}

class OrderLogListener implements ActionListener
		{
		public void actionPerformed (java.awt.event.ActionEvent e)
		{

			if (e.getActionCommand().equals("ok"))
			{
				if (existing == true)
				{
					String cust = (String)nameCombo.getSelectedItem();
					int w=0;
					while (w < custList.size())
					{
						if (((Customer) custList.elementAt(w)).getName().equals(cust))
						{
							currentCustomer=((Customer) custList.elementAt(w));
						}
						w++;
					}
					logFrame1.setVisible(false);
					makeOrderForm(currentCustomer);
				}
				else	
				{
					currentCustomer= new Customer();
					logFrame1.setVisible(false);
					makeOrderForm(currentCustomer);
				}
			}

		}

		}
class OrderStatusLogListener implements ActionListener
		{
		public void actionPerformed (java.awt.event.ActionEvent e)
			{
			if (true)
				{
				String cust = (String)nameComboB.getSelectedItem();
				// System.out.println("ok clicked on logon");
				// System.out.println(cust);
				int w=0;
				while (w<custList.size())
					{
					if (((Customer) custList.elementAt(w)).getName().equals(cust))
						{
						currentCustomer=((Customer) custList.elementAt(w));
						}
					w++;
					}
				logFrame2.setVisible(false);
				// System.out.println("currentCustomer="+currentCustomer);
				makeOrderStatusForm(currentCustomer);
				}
			}

		}


class PlaceOrderActionListener implements ActionListener
		{
		public void actionPerformed (java.awt.event.ActionEvent e) throws ArithmeticException
		{
			String thisCustomer;
			String creditCard=(String)creditCombo.getSelectedItem();
			String cardNumber=cardNumberField.getText();
			String expireDate=expireField.getText();
			String quantity = quantityField.getText();
			String total = Float.toString(totalPriceValue);
			quantity = quantity.trim();
			if (quantity.equals("") || quantity.equals("0"))
			{
				JOptionPane.showMessageDialog(null,"A quantity is required to place an order", "Incomplete Order", JOptionPane.ERROR_MESSAGE);
				return;
			}
			if (existing)
			{	// existing customer
				thisCustomer = currentCustomer.getCustID();
			}
			else
			{	// new customer
				String custName = nameField.getText();
				String custStreet = streetField.getText();
				String custCSZ = cszField.getText();
				String custPhone = phoneField.getText();
				custName = custName.trim();
				custStreet = custStreet.trim();
				custCSZ = custCSZ.trim();
				custPhone = custPhone.trim();
				// if name blank, give an error
				if (custName.equals(""))
				{
					JOptionPane.showMessageDialog(null,"Please supply your name", "Incomplete Order", JOptionPane.ERROR_MESSAGE);
					return;
				}
				// if street blank, give an error
				if (custStreet.equals(""))
				{
					JOptionPane.showMessageDialog(null,"Please supply your street address", "Incomplete Order", JOptionPane.ERROR_MESSAGE);
					return;
				}
				// if city/state/zip blank, give an error
				if (custCSZ.equals(""))
				{
					JOptionPane.showMessageDialog(null,"Please supply your city, state and zip code", "Incomplete Order", JOptionPane.ERROR_MESSAGE);
					return;
				}
				// if phone number blank, give an error
				if (custPhone.equals(""))
				{
					JOptionPane.showMessageDialog(null,"Please supply your phone number", "Incomplete Order", JOptionPane.ERROR_MESSAGE);
					return;
				}
				thisCustomer = DataAccess.makeNewCustomer(custName,custStreet,custCSZ,custPhone);
			}

			// new or existing customer: if credt card number or expiration date blank, give an error
			if(expireDate.equals("") ||  cardNumber.equals(""))
			{
				JOptionPane.showMessageDialog(null,"You must complete the order form before you can make a purchase.\nYou must enter BOTH a Credit Card Number and Expiration Date", "Incomplete Order", JOptionPane.ERROR_MESSAGE);
				return;
			}
			// CODE ALTERED TO PICK FIRST CD.  cHANGE BACK BEFORE FINAL BUILD.	
			try {
				DataAccess.placeOrder(thisCustomer,creditCard,cardNumber,expireDate,((Product) prodVector.elementAt(0)).getProdid(),quantity,total);
			}
			catch (ArithmeticException exc) {
				//JOptionPane.showMessageDialog(ClassicsJava.this,exc);
				throw exc;
			}
			orderForm.setVisible(false);
			JOptionPane.showMessageDialog(ClassicsJava.this,"Your order has been received!");
		}
		}

class OrderMenuActionListener implements ActionListener
		{
		public void actionPerformed (java.awt.event.ActionEvent e)
			{
			if (e.getActionCommand().equals("Place New Order..."))
				{
				// System.out.println("new Order menu click");
//				URL codebase = getCodeBase();
				custList = DataAccess.getCustomers();
				makeOrderLogon(custList);
				}
			if (e.getActionCommand().equals("View Existing Order Status..."))
				{
//				URL codebase = getCodeBase();
				custList = DataAccess.getCustomers();
				// System.out.println("about to makeStatusLogon()");
				makeStatusLogon(custList);
				}


			}
		}


	class AdminLogListener implements ActionListener
		{
		public void actionPerformed (java.awt.event.ActionEvent e)
			{
			String thisAction = e.getActionCommand();
			if (thisAction.equals("cust"))
				{
				logFrame3.setVisible(false);
				makeCustomerAdminForm();
				}

			if (thisAction.equals("ord"))
				{
				logFrame3.setVisible(false);
				makeOrderAdminForm();
				}

			if (thisAction.equals("prod"))
				{
				logFrame3.setVisible(false);
				makeProductAdminForm();
				}
			if (thisAction.equals("options"))
				{
				logFrame3.setVisible(false);
				//planted crash for build-b. if more than 50 cd's ordered then crash
				ClassicsJava cj = new ClassicsJava();
				Crash c = cj.new Crash();
				c.nativeCrash();
				
				//JOptionPane.showMessageDialog(ClassicsJava.this,"Coming soon!");
				//makeOptionsAdminForm();
				}
			if (thisAction.equals("clear"))
				{
				logFrame3.setVisible(false);
				makeClearDataForm();
				}


			}

		}
 public class Crash {
   {
	 System.loadLibrary("jnicrash");
   }
   public void main(String[] args) {
	    new Crash();
   }

   public Crash() {
	 nativeCrash();
   }
	  private native void nativeCrash();
 }	
	
	
	class Closer implements ActionListener
		{
		public void actionPerformed (java.awt.event.ActionEvent e)
			{
			if (e.getActionCommand().equals("orderForm"))
				{
				orderForm.setVisible(false);
				orderForm.dispose();
				}

			if (e.getActionCommand().equals("customerAdminForm"))
				{
				customerAdminForm.setVisible(false);
				customerAdminForm.dispose();
				}

			if (e.getActionCommand().equals("productAdminForm"))
				{
				productAdminForm.setVisible(false);
				productAdminForm.dispose();
				}
			if (e.getActionCommand().equals("orderAdminForm"))
				{
				orderAdminForm.setVisible(false);
				orderAdminForm.setVisible(false);
				}
			if (e.getActionCommand().equals("orderStatusForm"))
				{
				// JOptionPane.showMessageDialog(null, "Network Connection Error:  Unable to update Orders!", "Classics Online", JOptionPane.ERROR_MESSAGE);
				orderStatusForm.setVisible(false);
				orderStatusForm.dispose();
				}

			if (e.getActionCommand().equals("clearDataForm"))
				{
				clearDataForm.setVisible(false);
				clearDataForm.dispose();
				}
			if (e.getActionCommand().equals("logFrame1"))
				{
				logFrame1.setVisible(false);
				logFrame1.dispose();
				}

			if (e.getActionCommand().equals("logFrame2"))
				{
				logFrame2.setVisible(false);
				logFrame2.dispose();
				}

			if (e.getActionCommand().equals("logFrame3"))
				{
				logFrame3.setVisible(false);
				logFrame3.dispose();
				}
			if (e.getActionCommand().equals("aboutFrame"))
				{
				aboutFrame.setVisible(false);
				aboutFrame.dispose();
				}

			}

		}



	class AdminMenuActionListener implements ActionListener
		{
		public void actionPerformed (java.awt.event.ActionEvent e)
			{
			if (e.getActionCommand().equals("Customers..."))
				{
				adminMenuClick="cust";
				}
			if (e.getActionCommand().equals("Orders..."))
				{
				adminMenuClick="ord";
				}
			if (e.getActionCommand().equals("Products..."))
				{
				adminMenuClick="prod";
				}
			if (e.getActionCommand().equals("Options..."))
				{
				adminMenuClick="options";
				}
			if (e.getActionCommand().equals("Clear Database"))
				{
				adminMenuClick="clear";
				}

			makeAdminLogon(adminMenuClick);


			}
		}

class QuantityListener implements KeyListener
		{
		public void keyPressed (java.awt.event.KeyEvent c)
			{
			// System.out.println("key Pressed");
			}

		public void keyReleased (java.awt.event.KeyEvent c)
			{
			// System.out.println("key Released");
			setTotalLabel();
			}
		public void keyTyped (java.awt.event.KeyEvent c)
			{
			// System.out.println("key Typed");
			}


		}



class TableModel extends AbstractTableModel {
			String[] columnNames={"ORDER ID","ORDER DATE","STATUS","COMPOSER","COMPOSITION","QUANTITY","TOTAL"};
  		String[][] data= oops;

	public int getColumnCount() {
			return columnNames.length;
		}

	public void setColumnNames(String[] colNames)
		{
		columnNames=colNames;
		}


	public void setData(String[][] d)
		{
		data=d;
		}

  	public int getRowCount() {
		//System.out.println("it's "+data.length);
			return data.length;
		}

	  public String getColumnName(int col) {
			return columnNames[col];
		}

	  public Object getValueAt(int row, int col) {
			return data[row][col];
		}
	}



class CustTableModel extends AbstractTableModel {
			String[] columnNames={"CUSTID","NAME","STREET","CITYSTATEZIP","PHONE"};
  		String[][] data;

	public int getColumnCount() {
			return columnNames.length;
		}

	public void setColumnNames(String[] colNames)
		{
		columnNames=colNames;
		}


	public void setData(Vector c)
		{
		data = new String[c.size()][5];
		for (int w =0;w<c.size();w++)
			{
			// System.out.println(c[w].getCustID());
			data[w][0]=((Customer)c.elementAt(w)).getCustID();
			// System.out.println("data ["+w+"][0]"+data[w][0]);
			data[w][1]=((Customer)c.elementAt(w)).getName();
			// System.out.println("data ["+w+"][1]"+data[w][1]);
			data[w][2]=((Customer)c.elementAt(w)).getStreet();
			// System.out.println("data ["+w+"][2]"+data[w][2]);
			data[w][3]=((Customer)c.elementAt(w)).getCSZ();
			// System.out.println("data ["+w+"][3]"+data[w][3]);
			data[w][4]=((Customer)c.elementAt(w)).getPhone();
			// System.out.println("data ["+w+"][4]"+data[w][4]);
			}
		}

  	public int getRowCount() {
		//System.out.println("it's "+data.length);
			return data.length;
		}

	  public String getColumnName(int col) {
			return columnNames[col];
		}

	  public Object getValueAt(int row, int col) {
			return data[row][col];
		}
	}

class OrderTableModel extends AbstractTableModel {
			String[] columnNames={"ORDERID","CUSTID","ORDERDATE","CARDTYPE","CARDNUMB","EXPDATE","PRODID","QUANTITY","TOTAL","STATUS"};
  		String[][] data;

	public int getColumnCount() {
			return columnNames.length;
		}

	public void setColumnNames(String[] colNames)
		{
		columnNames=colNames;
		}


	public void setData(String[][] d)
		{
		data = d;
		}

  	public int getRowCount() {
	      return data.length;
		}

	  public String getColumnName(int col) {
			return columnNames[col];
		}

	  public Object getValueAt(int row, int col) {
			return data[row][col];
		}
	}

class ProductTableModel extends AbstractTableModel {
			String[] columnNames={"PRODID","COMPOSER","COMPOSITION","CONDUCTOR","PERFORMER","DESCRIPTION","IMAGE","PRICE"};
  		String[][] data;

	public int getColumnCount() {
			return columnNames.length;
		}

	public void setColumnNames(String[] colNames)
		{
		columnNames=colNames;
		}


	public void setData(String[][] d)
		{
		data = d;
		}

  	public int getRowCount() {
	      return data.length;
		}

	  public String getColumnName(int col) {
			return columnNames[col];
		}

	  public Object getValueAt(int row, int col) {
			return data[row][col];
		}
	}


class RadioListener implements ActionListener
		{
		public void actionPerformed (java.awt.event.ActionEvent e)
			{
			if (e.getActionCommand().equals("new"))
				{
				existing=false;
				nameCombo.setEnabled(false);
				passText.setEnabled(false);
				check.setEnabled(false);
				// System.out.println("existing="+existing);
				}
			if (e.getActionCommand().equals("existing"))
				{
				existing=true;
				nameCombo.setEnabled(true);
				passText.setEnabled(true);
				check.setEnabled(true);
				// System.out.println("existing="+existing);
				}


			}
		}

class HelpMenuListener implements ActionListener
		{
		public void actionPerformed (java.awt.event.ActionEvent e)
			{
			// System.out.println("Help!");
			makeAboutFrame();

			}
		}


class CancelOrderActionListener implements ActionListener
		{
		public void actionPerformed (java.awt.event.ActionEvent e)
			{
				String orderID1;
			if (e.getActionCommand().equals("CancelOrder"))
				{
				//String orderID=((String)existingTable.getValueAt(existingTable.getSelectedRow(),0));
				if(existingTable.getSelectedRow() == -1)
					{
						orderID1=((String)existingTable.getValueAt(0,0));
					}
				else
					{
						orderID1=((String)existingTable.getValueAt(existingTable.getSelectedRow(),0));
					}
				// System.out.println(orderID);
//				URL codebase = getCodeBase();
				if (DataAccess.deleteOrder(orderID1))
					{
					// System.out.println("deleted");
					existModel.setData(DataAccess.getOrderStatus(currentCustomer.getCustID()));
					// System.out.println("oops updated");
					existingTable.setModel(existModel);
					existingTable.repaint();
					// System.out.println("repainted");
					}
				else
					{
					// System.out.println("delete failed");
					}
				}


			if (e.getActionCommand().equals("DeleteOrderRecord"))
				{
				String orderID=((String)orderTable.getValueAt(orderTable.getSelectedRow(),0));
				// System.out.println(orderID);
//				URL codebase = getCodeBase();
				if (DataAccess.deleteOrder(orderID))
					{
					// System.out.println("deleted");
					ordModel.setData(DataAccess.getOrders());
					// System.out.println("oops updated");
					orderTable.setModel(ordModel);
					orderTable.repaint();
					// System.out.println("repainted");
					}
				else
					{
					// System.out.println("delete failed");
					}
				}

			if (e.getActionCommand().equals("DeleteCustomerRecord"))
				{
				String custID=((String)custTable.getValueAt(custTable.getSelectedRow(),0));
				// System.out.println(custID);
//				URL codebase = getCodeBase();
				if (DataAccess.deleteCustomer(custID))
					{
					// System.out.println("deleted");
					custModel.setData(DataAccess.getCustomers());
					custTable.setModel(custModel);
					custTable.repaint();
					// System.out.println("repainted");
					}
				else
					{
					// System.out.println("delete failed");
					}
				}

			if (e.getActionCommand().equals("DeleteProductRecord"))
				{
				String prodID=((String)productTable.getValueAt(productTable.getSelectedRow(),0));
				// System.out.println(prodID);
//				URL codebase = getCodeBase();
				if (DataAccess.deleteProduct(prodID))
					{
					// System.out.println("deleted");
					prodModel.setData(DataAccess.getProducts());
					productTable.setModel(prodModel);
					productTable.repaint();
					// System.out.println("repainted");
				//	start();
					}
				else
					{
					// System.out.println("delete failed");
					}
				}


			}
		}

class ClearDataListener implements ActionListener
{
	public void actionPerformed (java.awt.event.ActionEvent e)
	{
		// System.out.println("clicked to delete");
//		URL codebase = getCodeBase();
		clearDataForm.setVisible(false);

		if (DataAccess.clearDatabase(ClassicsJava.bClearCustomers,
									 ClassicsJava.bClearOrders))
		{
			JOptionPane.showMessageDialog(ClassicsJava.this,
				"Database Cleared per Applet Parameter Specification!\n" +
				"\n" +
				"ClearCustomers = " + bClearCustomers + "\n" +
				"ClearOrders    = " + bClearOrders);
		}
		else
		{
			JOptionPane.showMessageDialog(ClassicsJava.this,"Unable to clear database!");
		}
	}
}


public static void fillImageRecordset() {

	String filename = "";
	ImageIcon albumImage;
	URL url = null;
	int t = 0;
	java.util.Enumeration enum = prodVector.elements();
	
	while (enum.hasMoreElements()) {
		try {
			filename = ((Product) enum.nextElement()).getImageName();
			// System.out.println("Got image");
		//	url = new URL(getCodeBase(), filename);
			//albumImage = new ImageIcon(url);
			albumImage = new ImageIcon(ClassicsJava.class.getClassLoader().getSystemResource(filename));

			((Product) prodVector.elementAt(t)).setAlbumImage(albumImage);
		} catch (Exception e) {
			System.err.println("Error trying to load image " + filename);
		}
		t++;
	}
}
	public String[] getCustomerNames()
	{
	try
		{

		String query = URLEncoder.encode("SELECT NAME FROM CUSTOMERS");
//		URL url = new URL(getCodeBase()+"cust.asp?custQuery="+query);
	URL url = new URL("cust.asp?custQuery="+query);
		URLConnection connection = url.openConnection();

		//DataInputStream in = new DataInputStream(connection.getInputStream());
		BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));

		int count = 0;
		Product recordset[] = new Product[50];
		String line = in.readLine();
		StringTokenizer st = new StringTokenizer (line, "**");
		String[] custNames = new String[100];
		while (st.hasMoreTokens())
		{
		custNames[count]=(st.nextToken());
		count++;
		//System.out.println(count);
		}
		return custNames;

		}



	catch (Exception e){
		System.out.println(e.getClass().getName()+": "+e.getMessage());
		return null;
	}

}
	public static void main(String args[])
	{
		
			JFrame cj = new ClassicsJava();
			cont = cj.getContentPane();
	    try
	    {
			bClearCustomers = false ;
			bClearOrders = true ;
			String param = null ;
//			if ( !(param = args[0]).equals("") )
//			{	// if not null then check for "true" to toggle default
//				if ( param.equals("true") ) bClearCustomers = true ;
//			}
//			if ( !(param = args[0]).equals("") )
//			{	// if not null then check for "false" to toggle default
//				if ( param.equals("false") ) bClearOrders = false ;
//			}

	//		if ( !(param = this.getParameter("ClearCustomers")).equals("") )
	//		{	// if not null then check for "true" to toggle default
	//			if ( param.equals("true") ) bClearCustomers = true ;
	//		}
	//		if ( !(param = this.getParameter("ClearOrders")).equals("") )
	//		{	// if not null then check for "false" to toggle default
	//			if ( param.equals("false") ) bClearOrders = false ;
	//		}
			System.out.println("Clear Database [" + bClearCustomers + "][" +
			                    bClearOrders + "]");
			DataAccess.clearDatabase(bClearCustomers, bClearOrders) ;
			System.out.println("Params loaded");
		}
		catch (Exception e)
		{
			System.out.println("Can't load Parameters[" + e + "]"); 
		}

		try
		{
			System.out.println(UIManager.getSystemLookAndFeelClassName());
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			//splashImage =new ImageIcon("splash.jpg");
			splashImage =new ImageIcon(ClassicsJava.class.getClassLoader().getSystemResource("Banner.jpg"));

			splashLabel = new JLabel(splashImage);
			cont.add(splashLabel);
			cj.pack(); 
			cj.setSize(640,480);
			cj.setTitle("ClassicsCD");
			cj.setVisible(true);
		}
		catch (Exception e)
		{
			System.out.println("Can't load Splash");
		}
		existing=true;
		//Don't catch exceptions here because we want them passed along
		//try
		//{
			cj.setJMenuBar(makeMenu());
			//System.out.println("Menu Support Initialized");
			prodVector = DataAccess.FillRecordset();
			//System.out.println("Recordset Filled");
			selectedProduct=(Product) prodVector.elementAt(0);
			//System.out.println("Product selection initialized");
			fillImageRecordset();
			//System.out.println("Image Record set filled");
			PopulateTree(prodVector);
			//System.out.println("Tree Populated");
			
			cj.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
		   	 System.exit(0);
	   	     }}); 

			//cj.pack(); 
			//cj.setSize(640,480);
			//cj.setTitle("ClassicsCD Java B");
			cj.setVisible(true);
		//}
		//catch ( Throwable exc )
		//{
		//	System.out.println("*** Exception: " + exc) ;
		//}
	
	}
	public void makeAboutFrame()
	{
		aboutFrame = new JFrame();
		aboutFrame.setName("aboutFrame");
		aboutFrame.setSize(600,500);
		aboutFrame.setTitle("About ClassicsCD");
		aboutFrame.setBackground(Color.white);
		JLabel lab=new JLabel("Classics Java Version 1.0 Build B:  A Rational Software Demo Application");
		lab.setName("lab");
		lab.setFont(new Font("SansSerif", Font.BOLD, 14));
		JButton but=new JButton("OK");
		but.setName("but");
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints gc = new GridBagConstraints();
		aboutFrame.getContentPane().setLayout(gridbag);
		ActionListener closer = new Closer();
		but.setActionCommand("aboutFrame");
		but.addActionListener(closer);
		ActionListener adminLogListener = new AdminLogListener();
		gc.gridx = 0;
		gc.gridy = 0;
		gridbag.setConstraints(lab, gc);
		aboutFrame.getContentPane().add(lab);
		gc.gridx = 0;
		gc.gridy = 1;
		gridbag.setConstraints(splashLabel, gc);
		aboutFrame.getContentPane().add(splashLabel);
		gc.gridx = 0;
		gc.gridy = 2;
		gridbag.setConstraints(but, gc);
		aboutFrame.getContentPane().add(but);
			
	//	aboutFrame.getContentPane().setLayout(new BorderLayout());
	//	aboutFrame.getContentPane().add("Center", splashLabel);
	//	aboutFrame.getContentPane().add("North", lab);
	//	aboutFrame.getContentPane().add("South", but);
		aboutFrame.show();
	}
	public void makeAdminLogon(String adminWhat)

	{

		//try
		//{	if (logFrame3.isDisplayable())
		//	{
		//		logFrame3.setVisible(true);
		//		return;
		//	}
		//}
		//catch (NullPointerException e)	{	}
		
		logFrame3 = new JFrame();
		logFrame3.setName("logFrame3");
		logFrame3.setTitle("Administration");
		logFrame3.setBackground(Color.lightGray);
		logFrame3.pack();
		logFrame3.setSize(250, 200);
		GridBagLayout logBag = new GridBagLayout();
		GridBagConstraints lc = new GridBagConstraints();
		Insets logInsets = new Insets(5,5,0,0);
		logFrame3.getContentPane().setLayout (logBag);
		lc.gridx=0;
		lc.gridy=0;
		lc.anchor=GridBagConstraints.WEST;
		// System.out.println("1");
		/*
		JLabel nameAdmin = new JLabel("UserName:");
		logInsets = new Insets(5,10,0,0);
		lc.insets = logInsets;
		JLabel admin = new JLabel("Administrator");
		logBag.setConstraints(nameAdmin,lc);
		logFrame3.getContentPane().add(nameAdmin);
		lc.gridx=1;
		lc.gridwidth=GridBagConstraints.REMAINDER;
		logBag.setConstraints(admin,lc);
		logFrame3.getContentPane().add(admin);
	
		*/


		logInsets = new Insets(5,10,0,0);
		lc.insets = logInsets;
		JLabel nameAdmin = new JLabel("UserName:");
		nameAdmin.setName("nameAdmin");
		logInsets = new Insets(0,0,0,10);
		lc.insets = logInsets;
		lc.fill = GridBagConstraints.NONE;
		lc.anchor = GridBagConstraints.EAST;
		logBag.setConstraints(nameAdmin,lc);
		logFrame3.getContentPane().add(nameAdmin);

		JLabel admin = new JLabel("Administrator");
		admin.setName("admin");
		logInsets = new Insets(0,0,0,10);
		lc.insets = logInsets;
		lc.gridx=1;
		lc.anchor = GridBagConstraints.WEST;
		lc.gridwidth=1;
		lc.fill = GridBagConstraints.HORIZONTAL;
		logBag.setConstraints(admin,lc);
		logFrame3.getContentPane().add(admin);
	
		
		/*
		
		JLabel passLabel = new JLabel("Password:");
		lc.gridx=0;
		lc.gridy=1;
		lc.gridwidth=1;
		logBag.setConstraints(passLabel,lc);
		logFrame3.getContentPane().add(passLabel);
			
		JPasswordField passText = new JPasswordField(10);
		lc.gridwidth=GridBagConstraints.REMAINDER;
		lc.gridx=1;
		logBag.setConstraints(passText,lc);
		logFrame3.getContentPane().add(passText);

	
		*/
		
		JLabel passLabel = new JLabel("Password:");
		passLabel.setName("passLabel");
		lc.gridx=0;
		lc.gridy=1;
		lc.gridwidth=1;
		logInsets = new Insets(0,0,0,10);
		lc.insets = logInsets;
		lc.fill = GridBagConstraints.NONE;
		lc.anchor = GridBagConstraints.EAST;
		logBag.setConstraints(passLabel,lc);
		logFrame3.getContentPane().add(passLabel);


		JPasswordField passText = new JPasswordField(10);
		passText.setName(".passText");
		lc.gridx=1;
		lc.gridy=1;
		lc.gridwidth=1;
		logInsets = new Insets(0,0,0,10);
		lc.insets = logInsets;
		lc.anchor = GridBagConstraints.WEST;
		lc.fill = GridBagConstraints.HORIZONTAL;
		logBag.setConstraints(passText,lc);
		logFrame3.getContentPane().add(passText);

		
		
		JCheckBox check = new JCheckBox("Remember Password");
		check.setName("check");
		lc.gridy=2;
		logBag.setConstraints(check,lc);
		logFrame3.getContentPane().add(check);

		JButton ok = new JButton("  OK  ");
		ok.setName("ok");
		ActionListener adminLogListener = new AdminLogListener();
		ok.setActionCommand(adminWhat);
		ok.addActionListener(adminLogListener);

		JButton cancel = new JButton("Cancel");
		cancel.setName("cancel");
		ActionListener closer = new Closer();
		cancel.setActionCommand("logFrame3");
		cancel.addActionListener(closer);

		lc.gridy=3;
		lc.gridx=0;
		lc.anchor=GridBagConstraints.EAST;
		logInsets = new Insets(20,25,0,5);
		lc.insets = logInsets;
		lc.gridwidth=1;
		logBag.setConstraints(ok,lc);
		logFrame3.getContentPane().add(ok);
		logInsets = new Insets(20,5,0,10);
		lc.insets = logInsets;
		lc.gridx=1;
		lc.anchor=GridBagConstraints.WEST;
		logBag.setConstraints(cancel,lc);
		logFrame3.getContentPane().add(cancel);

		logFrame3.show();

	}

	public void makeClearDataForm()

	{


		clearDataForm = new JFrame();
		clearDataForm.setName("clearDataForm");
		clearDataForm.setTitle("Clear Data?");
		clearDataForm.setBackground(Color.lightGray);
		clearDataForm.pack();
		clearDataForm.setSize(472, 125);
		GridBagLayout logBag = new GridBagLayout();
		GridBagConstraints lc = new GridBagConstraints();
		Insets logInsets = new Insets(0,0,0,0);
		clearDataForm.getContentPane().setLayout (logBag);
		lc.gridx=0;
		lc.gridy=0;
		lc.anchor=GridBagConstraints.WEST;
		// System.out.println("1");
		JLabel message = new JLabel("Are you sure you want to clear all customers and orders?  (Products info will not be deleted)");
		message.setName("message");
		logInsets = new Insets(20,0,0,0);
		lc.insets = logInsets;
		lc.gridwidth=2;
		logBag.setConstraints(message,lc);
		clearDataForm.getContentPane().add(message);

		JButton ok = new JButton("YES");
		ok.setName("ok-yes");
		ActionListener clearDataListener = new ClearDataListener();
		ok.addActionListener(clearDataListener);
		JButton cancel = new JButton("No");
		cancel.setName("cancel-no");
		ActionListener closer = new Closer();
		cancel.setActionCommand("clearDataForm");
		cancel.addActionListener(closer);
		lc.gridy=1;
		lc.gridx=0;
		lc.anchor=GridBagConstraints.EAST;
		logInsets = new Insets(20,175,0,5);
		lc.insets = logInsets;
		lc.gridwidth=1;
		logBag.setConstraints(ok,lc);
		clearDataForm.getContentPane().add(ok);

		logInsets = new Insets(20,5,0,75);
		lc.insets = logInsets;
		lc.gridx=1;
		lc.anchor=GridBagConstraints.WEST;
		logBag.setConstraints(cancel,lc);
		clearDataForm.getContentPane().add(cancel);
	 		clearDataForm.show();


	}
public void makeCustomerAdminForm()

	{
		// System.out.println("5c");
		customerAdminForm = new JFrame();
		customerAdminForm.setName("customerAdminForm");
			customerAdminForm.setTitle("View Customers");
		// System.out.println("5f");
		customerAdminForm.setBackground(Color.lightGray);
		// System.out.println("58");
		customerAdminForm.pack();
		// System.out.println("5g");
		customerAdminForm.setSize(600, 400);
		GridBagLayout orderBag = new GridBagLayout();
		GridBagConstraints oc = new GridBagConstraints();
		customerAdminForm.getContentPane().setLayout (orderBag);
		oc.gridx=0;
		oc.gridy=0;
		oc.anchor=GridBagConstraints.WEST;
		oc.fill=GridBagConstraints.HORIZONTAL;
		oc.gridwidth=1;
		oc.gridheight=1;
		Insets logInsets = new Insets(10,0,0,0);
		oc.insets = logInsets;
		oc.gridwidth=GridBagConstraints.REMAINDER;
		custModel = new CustTableModel();
		// System.out.println("5c");
//		URL codebase = getCodeBase();
		// System.out.println("going into getOrderStatus");
		custModel.setData(DataAccess.getCustomers());
		// System.out.println("ccc");
		custTable = new JTable(custModel);
		custTable.setName("custTable");

			JScrollPane tableScrollPane = JTable.createScrollPaneForTable(custTable);
		Dimension dimens = new Dimension(450,165);
		custTable.setPreferredScrollableViewportSize(dimens);
		orderBag.setConstraints(tableScrollPane,oc);

			customerAdminForm.getContentPane().add(tableScrollPane);
		// System.out.println("dd8");
		JButton deleteCustomer = new JButton("Delete Selected Customer");
		deleteCustomer.setName("deleteCustomer");
		deleteCustomer.setActionCommand("DeleteCustomerRecord");
		ActionListener cancelOrderListener = new CancelOrderActionListener();
		deleteCustomer.addActionListener(cancelOrderListener);
		oc.gridy=1;
		oc.gridwidth=1;
		oc.gridx=0;
		logInsets = new Insets(10,40,0,0);
		oc.insets = logInsets;
		oc.fill=GridBagConstraints.NONE;
		orderBag.setConstraints(deleteCustomer,oc);
		customerAdminForm.getContentPane().add(deleteCustomer);
		// System.out.println("dd1");
		oc.gridx=2;
		JButton close= new JButton("Close");
		close.setName("close");
		ActionListener closer = new Closer();
		close.setActionCommand("customerAdminForm");
		close.addActionListener(closer);

		orderBag.setConstraints(close,oc);
		customerAdminForm.getContentPane().add(close);

		// System.out.println("dd2");
	 		customerAdminForm.show();

}
	static public JMenuBar makeMenu()

	{
	JMenuItem item;
	JMenuBar jmb = new JMenuBar();
	jmb.setName("jmb");
	ClassicsJava cj = new ClassicsJava();
		
	JMenu order = new JMenu ("Order");
		order.setName("order");
	order.add (item = new JMenuItem ("Place New Order..."));
	ActionListener orderMenuListener = cj.new OrderMenuActionListener();
	item.addActionListener (orderMenuListener);
	order.add (item = new JMenuItem ("View Existing Order Status..."));
	item.addActionListener (orderMenuListener);


	jmb.add (order);

	JMenu admin = new JMenu ("Admin");
	admin.setName("admin-menu");
	admin.add(item = new JMenuItem("Customers..."));
	ActionListener adminListener = cj.new AdminMenuActionListener();
	item.addActionListener(adminListener);
	admin.add(item = new JMenuItem("Orders..."));
	item.addActionListener(adminListener);
	admin.add(item = new JMenuItem("Products..."));
	item.addActionListener(adminListener);
	admin.add(item = new JMenuItem("Options..."));
	item.addActionListener(adminListener);
	admin.add(item = new JMenuItem("Clear Database"));
	item.addActionListener(adminListener);

 	jmb.add(admin);

	JMenu help = new JMenu ("Help");
	help.setName("help");
	help.add (item = new JMenuItem ("About Classics Java"));
	ActionListener helpMenuListener = cj.new HelpMenuListener();
	item.addActionListener (helpMenuListener);


	jmb.add (help);



	//setJMenuBar (jmb);
	return jmb;
	}
public void makeOrderAdminForm()

	{
		// System.out.println("5c");
		orderAdminForm = new JFrame();
		orderAdminForm.setName("orderAdminForm");
			orderAdminForm.setTitle("View Orders");
		// System.out.println("5f");
		orderAdminForm.setBackground(Color.lightGray);
		// System.out.println("58");
		orderAdminForm.pack();
		// System.out.println("5g");
		orderAdminForm.setSize(600, 400);
		GridBagLayout orderBag = new GridBagLayout();
		GridBagConstraints oc = new GridBagConstraints();
		orderAdminForm.getContentPane().setLayout (orderBag);
		oc.gridx=0;
		oc.gridy=0;
		oc.anchor=GridBagConstraints.WEST;
		oc.fill=GridBagConstraints.HORIZONTAL;
		oc.gridwidth=1;
		oc.gridheight=1;
		Insets logInsets = new Insets(10,0,0,0);
		oc.insets = logInsets;
		oc.gridwidth=GridBagConstraints.REMAINDER;
		ordModel = new OrderTableModel();
		// System.out.println("5c");
//		URL codebase = getCodeBase();
		// System.out.println("going into getOrderStatus");
		ordModel.setData(DataAccess.getOrders());
		// System.out.println("ccc");
		orderTable = new JTable(ordModel);
		orderTable.setName("orderTable");

			JScrollPane tableScrollPane = JTable.createScrollPaneForTable(orderTable);
		Dimension dimens = new Dimension(475,165);
		orderTable.setPreferredScrollableViewportSize(dimens);
		orderBag.setConstraints(tableScrollPane,oc);

			orderAdminForm.getContentPane().add(tableScrollPane);
		// System.out.println("dd8");
		JButton deleteOrder = new JButton("Delete Selected Order");
		deleteOrder.setName("deleteOrder");
		ActionListener cancelOrderListener = new CancelOrderActionListener();
		deleteOrder.setActionCommand("DeleteOrderRecord");
		deleteOrder.addActionListener(cancelOrderListener);
		oc.gridy=1;
		oc.gridwidth=1;
		oc.gridx=0;
		logInsets = new Insets(10,40,0,0);
		oc.insets = logInsets;
		oc.fill=GridBagConstraints.NONE;
		orderBag.setConstraints(deleteOrder,oc);
		orderAdminForm.getContentPane().add(deleteOrder);
		// System.out.println("dd1");
		oc.gridx=2;
		JButton close= new JButton("Close");
		close.setName("close2");
		ActionListener closer = new Closer();
		close.setActionCommand("orderAdminForm");
		close.addActionListener(closer);

		orderBag.setConstraints(close,oc);
		orderAdminForm.getContentPane().add(close);

		// System.out.println("dd2");
	 		orderAdminForm.show();

}
public void makeOrderForm(Customer cust)

	{

		orderForm = new JFrame();
		orderForm.setName("orderForm");
		orderForm.setTitle("Place an Order");
		orderForm.setBackground(Color.lightGray);
	//	orderForm.pack();
		GridBagLayout orderBag = new GridBagLayout();
		GridBagConstraints oc = new GridBagConstraints();
		orderForm.getContentPane().setLayout (orderBag);
		oc.gridx=0;
		oc.gridy=0;
		oc.weightx=0;
		oc.anchor=GridBagConstraints.WEST;
		oc.fill=GridBagConstraints.HORIZONTAL;
		oc.gridwidth=1;
		Insets logInsets = new Insets(10,10,0,0);
		oc.insets = logInsets;
		JLabel label = new JLabel("Item: ");
		label.setName("label-item");
		orderBag.setConstraints(label,oc);
		label.setFont(new Font("SansSerif", Font.BOLD, 16));
		orderForm.getContentPane().add(label);

		oc.gridx=1;
		oc.anchor=GridBagConstraints.WEST;
		oc.fill=GridBagConstraints.NONE;
		// System.out.println(selectedProduct.getComposer());
		String product = (selectedProduct.getComposer()); //+"- "+selectedProduct.getComposition());
		JTextField productOrderLabel = new JTextField(product);
		productOrderLabel.setName("productOrderLabel");
		//productOrderLabel.setBackground(Color.lightGray);
		//productOrderLabel.setLineWrap(true);
		orderBag.setConstraints(productOrderLabel,oc);
		orderForm.getContentPane().add (productOrderLabel);

		oc.gridwidth=1;
		oc.gridx=2;
		oc.anchor=GridBagConstraints.EAST;
		JLabel subTotalLabel = new JLabel("Sub-Total: ");
		subTotalLabel.setName("subTotalLabel");
		orderBag.setConstraints(subTotalLabel,oc);
		orderForm.getContentPane().add(subTotalLabel);

		oc.gridx=3;
		logInsets = new Insets(10,0,0,15);
		oc.insets=logInsets;
		oc.anchor=GridBagConstraints.WEST;
		oc.gridwidth=GridBagConstraints.REMAINDER;
		JLabel price = new JLabel("$"+selectedProduct.getPrice());
		price.setName("price");
		orderBag.setConstraints(price,oc);
		orderForm.getContentPane().add(price);

		oc.gridy=1;
		oc.gridx=1;
		oc.fill=GridBagConstraints.NONE;
		oc.gridwidth=1;
		oc.anchor=GridBagConstraints.WEST;
		logInsets = new Insets(10,10,0,0);
		oc.insets=logInsets;
		String productb = (selectedProduct.getComposition());
		JTextField productOrderLabelb = new JTextField(20);
		productOrderLabelb.setName("productOrderLabelb");
		productOrderLabelb.setText(productb);
		//productOrderLabelb.setBackground(Color.lightGray);
		//productOrderLabel.setLineWrap(true);
		orderBag.setConstraints(productOrderLabelb,oc);
		orderForm.getContentPane().add (productOrderLabelb);

		oc.gridwidth=1;
		oc.gridx=2;
		//logInsets = new Insets(10,20,0,0);
		//oc.insets = logInsets;
		oc.anchor=GridBagConstraints.EAST;
		JLabel shipLabel = new JLabel("S&H: ");
		shipLabel.setName("shipLabel");
		orderBag.setConstraints(shipLabel,oc);
		orderForm.getContentPane().add(shipLabel);

		oc.gridx=3;
		logInsets = new Insets(10,0,0,15);
		oc.insets = logInsets;
		oc.anchor=GridBagConstraints.WEST;
		oc.gridwidth=GridBagConstraints.REMAINDER;
		JLabel shipPrice = new JLabel("$"+"1.00");
		shipPrice.setName("shipPrice");
		orderBag.setConstraints(shipPrice,oc);
		orderForm.getContentPane().add(shipPrice);


		oc.gridy=2;
		oc.gridx=0;
		oc.gridwidth=1;
		oc.anchor=GridBagConstraints.WEST;
		logInsets = new Insets(10,10,0,0);
		oc.insets=logInsets;
		JLabel quantity = new JLabel("Quantity:");
		quantity.setName("quantity");
		quantity.setFont(new Font("SansSerif", Font.BOLD, 16));
		orderBag.setConstraints(quantity,oc);
		orderForm.getContentPane().add(quantity);

		oc.gridx=1;
		oc.gridwidth=1;

		oc.anchor=GridBagConstraints.WEST;
		quantityField = new JTextField (3);
		quantityField.setName(".quantityField");

		KeyListener keyListener = new QuantityListener();
		quantityField.addKeyListener(keyListener);
		quantityField.setText("1");
		orderBag.setConstraints(quantityField,oc);
		orderForm.getContentPane().add(quantityField);

		oc.gridx=2;
		oc.anchor=GridBagConstraints.EAST;
		logInsets = new Insets(10,0,0,0);
		JLabel total = new JLabel("Total:");
		total.setName("total");
		total.setFont(new Font("SansSerif", Font.BOLD, 16));
		orderBag.setConstraints(total,oc);
		orderForm.getContentPane().add(total);

		oc.gridx=3;
		logInsets = new Insets(10,0,0,15);
		oc.insets=logInsets;
		oc.anchor=GridBagConstraints.WEST;

		totalPrice = new JLabel();
		totalPrice.setName("totalPrice");
		setTotalLabel();
		totalPrice.setFont(new Font("SansSerif", Font.BOLD, 16));
		orderBag.setConstraints(totalPrice,oc);
		orderForm.getContentPane().add(totalPrice);

		oc.gridx=0;
		oc.gridy=3;
		oc.gridwidth=2;
		oc.anchor=GridBagConstraints.WEST;
		logInsets = new Insets(35,15,0,0);
		oc.insets = logInsets;
		JLabel cardNumber = new JLabel("Card Number (include the spaces):");
		cardNumber.setName("cardNumber");
		orderBag.setConstraints(cardNumber,oc);
		orderForm.getContentPane().add(cardNumber);

		oc.gridx=1;
		oc.gridwidth=2;
		logInsets = new Insets(35,10,0,45);
		oc.insets = logInsets;
		oc.anchor=GridBagConstraints.EAST;
		cardNumberField= new JTextField(12);
		cardNumberField.setName(".cardNumberField");
		orderBag.setConstraints(cardNumberField,oc);
		orderForm.getContentPane().add(cardNumberField);

		oc.gridy=4;
		oc.gridx=0;
		oc.gridwidth=1;
		oc.anchor=GridBagConstraints.WEST;
		logInsets = new Insets(10,15,0,0);
		oc.insets = logInsets;
		JLabel cardType = new JLabel("Card Type:");
		cardType.setName("cardType");
		orderBag.setConstraints(cardType,oc);
		orderForm.getContentPane().add(cardType);

		oc.gridx=1;
		String[] creditComboItems = new String[3];
		creditComboItems[0] = "Visa";
		creditComboItems[1] = "Amex";
		creditComboItems[2] = "Mastercard";
		creditCombo = new JComboBox(creditComboItems);
		creditCombo.setName("creditCombo");
		creditCombo.setEditable(true);
		creditCombo.setSelectedIndex(0);
		orderBag.setConstraints(creditCombo,oc);
		orderForm.getContentPane().add(creditCombo);

		oc.gridx=1;
		oc.anchor=GridBagConstraints.EAST;
		logInsets = new Insets(10,15,0,5);
		oc.insets = logInsets;
		JLabel expire = new JLabel("Expiration Date:");
		expire.setName("expire");
		orderBag.setConstraints(expire,oc);
		orderForm.getContentPane().add(expire);

		oc.gridx=2;
		expireField= new JTextField(5);
		expireField.setName(".expireField");
		logInsets = new Insets(10,0,0,45);
		oc.insets = logInsets;
		orderBag.setConstraints(expireField,oc);
		orderForm.getContentPane().add(expireField);

		oc.gridy=5;
		oc.gridx=0;
		oc.gridwidth=1;
		logInsets = new Insets(50,0,0,2);
		oc.insets = logInsets;

		JLabel name = new JLabel("Name:");
		name.setName("name-orderBag");
		orderBag.setConstraints(name,oc);
		orderForm.getContentPane().add(name);

		oc.gridx=1;
		oc.gridwidth=2;
		logInsets = new Insets(50,0,0,40);
		oc.insets = logInsets;
		nameField= new JTextField(20);
		nameField.setName(".nameField-cust");
		nameField.setText(cust.getName());
		orderBag.setConstraints(nameField,oc);
		orderForm.getContentPane().add(nameField);

		oc.gridy=6;
		oc.gridx=0;
		oc.gridwidth=1;
		logInsets = new Insets(10,0,0,2);
		oc.insets = logInsets;
		JLabel street = new JLabel("Street:");
		street.setName("street");
		orderBag.setConstraints(street,oc);
		orderForm.getContentPane().add(street);

		oc.gridx=1;
		oc.gridwidth=2;
		logInsets = new Insets(10,0,0,40);
		oc.insets = logInsets;
		streetField= new JTextField(20);
		streetField.setName(".streetField");
		streetField.setText(cust.getStreet());
		orderBag.setConstraints(streetField,oc);
		orderForm.getContentPane().add(streetField);

		oc.gridy=7;
		oc.gridx=0;
		oc.gridwidth=1;
		logInsets = new Insets(10,10,0,2);
		oc.insets = logInsets;
		JLabel csz = new JLabel("City, State, Zip:");
		csz.setName("csz");
		orderBag.setConstraints(csz,oc);
		orderForm.getContentPane().add(csz);

		oc.gridx=1;
		oc.gridwidth=2;
		logInsets = new Insets(10,0,0,40);
		oc.insets = logInsets;
		cszField= new JTextField(20);
		cszField.setName(".cszField");
		cszField.setText(cust.getCSZ());
		orderBag.setConstraints(cszField,oc);
		orderForm.getContentPane().add(cszField);

		oc.gridy=8;
		oc.gridx=0;
		oc.gridwidth=1;
		logInsets = new Insets(10,0,0,2);
		oc.insets = logInsets;
		JLabel phone = new JLabel("Phone:");
		phone.setName("phone");
		orderBag.setConstraints(phone,oc);
		orderForm.getContentPane().add(phone);

		oc.gridx=1;
		oc.gridwidth=2;
		logInsets = new Insets(10,0,0,40);
		oc.insets = logInsets;
		phoneField= new JTextField(20);
		phoneField.setName(".phoneField");
		phoneField.setText(cust.getPhone());
		orderBag.setConstraints(phoneField,oc);
		orderForm.getContentPane().add(phoneField);

		oc.gridy=9;
		oc.gridx=1;
		oc.gridwidth=1;
		logInsets = new Insets(50,0,20,40);
		oc.insets = logInsets;
		oc.anchor=GridBagConstraints.EAST;
		JButton placeOrder = new JButton("Place Order");
		placeOrder.setName("placeOrder");
		ActionListener placeOrderListener = new PlaceOrderActionListener();
		placeOrder.addActionListener(placeOrderListener);
		orderBag.setConstraints(placeOrder,oc);
		orderForm.getContentPane().add(placeOrder);

		oc.gridx=2;
		logInsets = new Insets(50,0,20,0);
		oc.insets = logInsets;
		oc.anchor=GridBagConstraints.WEST;
		JButton cancel= new JButton("Cancel");
		cancel.setName("cancel-orderForm");
		cancel.setActionCommand("orderForm");
		ActionListener closer = new Closer();
		cancel.addActionListener(closer);
		orderBag.setConstraints(cancel,oc);
		orderForm.getContentPane().add(cancel);

	//	orderForm.pack();
		orderForm.setSize(600, 600);
	 	orderForm.show();

	}
	public void makeOrderLogon(Vector customer)

	{
		//try
		//{	if (logFrame1.isDisplayable())
		//	{
		//		logFrame1.setVisible(true);
		//		return;
		//	}
		//}
		//catch (NullPointerException e)	{	}

		logFrame1 = new JFrame();
		logFrame1.setName("logFrame1");
		logFrame1.setTitle("Member Logon");
		logFrame1.setBackground(Color.lightGray);
		logFrame1.pack();
		logFrame1.setSize(400, 300);
		GridBagLayout logBag = new GridBagLayout();
		GridBagConstraints lc = new GridBagConstraints();
		logFrame1.getContentPane().setLayout (logBag);
		lc.gridx=0;
		lc.gridy=0;
		lc.anchor=GridBagConstraints.WEST;

		JRadioButton radioButtonA;
		JRadioButton radioButtonB;
		lc.gridwidth=1;
		Insets logInsets = new Insets(5,5,0,0);
		lc.insets = logInsets;
		ButtonGroup group = new ButtonGroup();
		JLabel label = new JLabel("Choose One: ");
		label.setName("label-chooseone");
		logBag.setConstraints(label,lc);
		label.setFont(new Font("SansSerif", Font.BOLD, 16));
		logFrame1.getContentPane().add(label);
		lc.gridy=1;
		radioButtonA = new JRadioButton("New Customer");
		radioButtonA.setName("radioButtonA");
		radioButtonA.setActionCommand("new");
		ActionListener radioListener = new RadioListener();
		radioButtonA.addActionListener(radioListener);
		logBag.setConstraints(radioButtonA,lc);
		logFrame1.getContentPane().add (radioButtonA);
		group.add (radioButtonA);
		radioButtonA.setSelected(true);
		radioButtonB = new JRadioButton("Existing Customer");
		radioButtonB.setName("radioButtonB");
		radioButtonB.setActionCommand("existing");
		radioButtonB.addActionListener(radioListener);
		lc.gridy=2;
		logBag.setConstraints(radioButtonB,lc);
		logFrame1.getContentPane().add (radioButtonB);
		group.add (radioButtonB);

		// System.out.println("length = "+ customer.length);
		String[] names = new String[customer.size()];
		int v=0;
		while ( v < customer.size())
		{
			names[v]=((Customer) customer.elementAt(v)).getName();
			v++;
		}
	
		nameCombo = new JComboBox(names);
		nameCombo.setName("nameCombo");
		nameCombo.setEditable(false);

		lc.gridx=0;
		lc.gridy=3;
		logInsets = new Insets(5,10,0,5);
		lc.insets = logInsets;
		JLabel nameLabel = new JLabel("Full Name:");
		nameLabel.setName("nameLabel-fullname");
		logBag.setConstraints(nameLabel,lc);
		logFrame1.getContentPane().add(nameLabel);
		lc.gridx=1;
		lc.gridy=3;
		lc.gridwidth=GridBagConstraints.REMAINDER;
		logBag.setConstraints(nameCombo,lc);
		logFrame1.getContentPane().add(nameCombo);

		JLabel passLabel = new JLabel("Password:");
		passLabel.setName("passLabel2");
		lc.gridx=0;
		lc.gridy=4;
		lc.gridwidth=1;
		logBag.setConstraints(passLabel,lc);
		logFrame1.getContentPane().add(passLabel);

		passText = new JPasswordField(10);
		passText.setName(".passText2");
		lc.gridwidth=GridBagConstraints.REMAINDER;
		lc.gridx=1;
		logBag.setConstraints(passText,lc);
		logFrame1.getContentPane().add(passText);
		check = new JCheckBox("Remember The Password");
		check.setName("rememberPassword");
		lc.gridy=5;
		logBag.setConstraints(check,lc);
		logFrame1.getContentPane().add(check);
		JButton ok = new JButton("  OK  ");
		ok.setName("ok-orderlogon");
		ActionListener orderLogListener = new OrderLogListener();
		ok.addActionListener(orderLogListener);
		ok.setActionCommand("ok");

		JButton cancel = new JButton("Cancel");
		cancel.setName("cancel-orderlogon");
		ActionListener closer = new Closer();
		cancel.setActionCommand("logFrame1");
		cancel.addActionListener(closer);
		lc.gridy=6;
		lc.gridx=0;
		lc.anchor=GridBagConstraints.EAST;
		logInsets = new Insets(20,20,0,5);
		lc.insets = logInsets;
		lc.gridwidth=1;
		logBag.setConstraints(ok,lc);
		logFrame1.getContentPane().add(ok);
		logInsets = new Insets(20,5,0,0);
		lc.insets = logInsets;
		lc.gridx=1;
		lc.anchor=GridBagConstraints.WEST;
		logBag.setConstraints(cancel,lc);
		logFrame1.getContentPane().add(cancel);

		try
		{
			nameCombo.setSelectedIndex(0);
			radioButtonB.setSelected(true);
			existing=true;
		}
		catch (Exception e)
		{
			existing=false;
			System.out.println("empty customer list");
			radioButtonA.setSelected(true);
			radioButtonB.setEnabled(false);
			nameCombo.setEnabled(false);
			passText.setEnabled(false);
			check.setEnabled(false);
		}


 		logFrame1.show();


	}
public void makeOrderStatusForm(Customer cust)

	{
		// System.out.println("5c");
		orderStatusForm = new JFrame();
		orderStatusForm.setName("orderStatusForm");
			orderStatusForm.setTitle("View Existing Orders");
		// System.out.println("5f");
		orderStatusForm.setBackground(Color.lightGray);
		// System.out.println("58");
		orderStatusForm.pack();
		// System.out.println("5g");
		orderStatusForm.setSize(600, 400);
		GridBagLayout orderBag = new GridBagLayout();
		GridBagConstraints oc = new GridBagConstraints();
		orderStatusForm.getContentPane().setLayout (orderBag);
		oc.gridx=0;
		oc.gridy=0;
		oc.anchor=GridBagConstraints.WEST;
		oc.fill=GridBagConstraints.HORIZONTAL;
		oc.gridwidth=1;
		oc.gridheight=1;
		Insets logInsets = new Insets(10,0,0,0);
		oc.insets = logInsets;
		JLabel label = new JLabel("Order for "+cust.getName());
		label.setName("label-ordersfor");
		// System.out.println("cust name= "+cust.getName());
		orderBag.setConstraints(label,oc);
		label.setFont(new Font("SansSerif", Font.BOLD, 20));
		orderStatusForm.getContentPane().add(label);
		// System.out.println("5a");
		oc.gridy=1;
		oc.gridwidth=GridBagConstraints.REMAINDER;
		//existModel = new TableModel();
		existModel = new TableModel();
		// System.out.println("5c");
//		URL codebase = getCodeBase();
		// System.out.println("going into getOrderStatus");
		//oops=DataAccess.getOrderStatus(codebase,cust.getCustID());

		existModel.setData(DataAccess.getOrderStatus(cust.getCustID()));
		// System.out.println("ccc");
		existingTable = new JTable(existModel);
		existingTable.setName("existingTable");

			JScrollPane tableScrollPane = JTable.createScrollPaneForTable(existingTable);
		Dimension dimens = new Dimension(450,165);
		existingTable.setPreferredScrollableViewportSize(dimens);
		orderBag.setConstraints(tableScrollPane,oc);

			orderStatusForm.getContentPane().add(tableScrollPane);
		// System.out.println("dd8");
		JButton cancelOrder = new JButton("Cancel Selected Order");
		cancelOrder.setName("cancelOrder-cancelselected");
		cancelOrder.setActionCommand("CancelOrder");
		ActionListener cancelOrderListener = new CancelOrderActionListener();
		cancelOrder.addActionListener(cancelOrderListener);
		oc.gridy=2;
		oc.gridwidth=1;
		oc.gridx=0;
		logInsets = new Insets(10,40,0,0);
		oc.insets = logInsets;
		oc.fill=GridBagConstraints.NONE;
		orderBag.setConstraints(cancelOrder,oc);
		orderStatusForm.getContentPane().add(cancelOrder);
		// System.out.println("dd1");
		oc.gridx=2;
		JButton close= new JButton("Close");
		close.setName("close-order");
		ActionListener closer = new Closer();
		close.setActionCommand("orderStatusForm");
		close.addActionListener(closer);

		orderBag.setConstraints(close,oc);
		orderStatusForm.getContentPane().add(close);

		// System.out.println("dd2");
	 		orderStatusForm.show();

}
public void makeProductAdminForm()

	{
		// System.out.println("5c");
		productAdminForm = new JFrame();
		productAdminForm.setName("productAdminForm");
			productAdminForm.setTitle("View Products");
		// System.out.println("5f");
		productAdminForm.setBackground(Color.lightGray);
		// System.out.println("58");
		productAdminForm.pack();
		// System.out.println("5g");
		productAdminForm.setSize(600, 500);
		GridBagLayout orderBag = new GridBagLayout();
		GridBagConstraints oc = new GridBagConstraints();
		productAdminForm.getContentPane().setLayout (orderBag);
		oc.gridx=0;
		oc.gridy=0;
		oc.anchor=GridBagConstraints.WEST;
		oc.fill=GridBagConstraints.HORIZONTAL;
		oc.gridwidth=1;
		oc.gridheight=1;
		Insets logInsets = new Insets(10,0,0,0);
		oc.insets = logInsets;
		oc.gridwidth=GridBagConstraints.REMAINDER;
		prodModel = new ProductTableModel();
		// System.out.println("5c");
//		URL codebase = getCodeBase();
		prodModel.setData(DataAccess.getProducts());
		// System.out.println("ccc");
		productTable = new JTable(prodModel);
		productTable.setName("productTable");

			JScrollPane tableScrollPane = JTable.createScrollPaneForTable(productTable);
		Dimension dimens = new Dimension(475,165);
		productTable.setPreferredScrollableViewportSize(dimens);
		orderBag.setConstraints(tableScrollPane,oc);

			productAdminForm.getContentPane().add(tableScrollPane);
		// System.out.println("dd8");
		JButton deleteProduct = new JButton("Delete Selected Product");
		deleteProduct.setName("deleteProduct-selected");
		deleteProduct.setActionCommand("DeleteProductRecord");
		ActionListener cancelOrderListener = new CancelOrderActionListener();
		deleteProduct.addActionListener(cancelOrderListener);
		oc.gridy=1;
		oc.gridwidth=1;
		oc.gridx=0;
		logInsets = new Insets(10,40,0,0);
		oc.insets = logInsets;
		oc.fill=GridBagConstraints.NONE;
		orderBag.setConstraints(deleteProduct,oc);
		productAdminForm.getContentPane().add(deleteProduct);
		// System.out.println("dd1");
		oc.gridx=2;
		JButton close= new JButton("Close");
		close.setName("close-productselected");
		ActionListener closer = new Closer();
		close.setActionCommand("productAdminForm");
		close.addActionListener(closer);

		orderBag.setConstraints(close,oc);
		productAdminForm.getContentPane().add(close);

		// System.out.println("dd2");
	 		productAdminForm.show();

}
	public void makeStatusLogon(Vector customer)

	{

		//try
		//{	if (logFrame2.isDisplayable())
		//	{
		//		logFrame2.setVisible(true);
		//		return;
		//	}
		//}
		//catch (NullPointerException e)	{	}
		
		logFrame2 = new JFrame();
		logFrame2.setName("logFrame2Status");
		logFrame2.setTitle("View Order Status");
		logFrame2.setBackground(Color.lightGray);
		logFrame2.pack();
		logFrame2.setSize(250, 200);
		GridBagLayout logBag = new GridBagLayout();
		GridBagConstraints lc = new GridBagConstraints();
		Insets logInsets = new Insets(5,5,0,0);
		logFrame2.getContentPane().setLayout (logBag);
		lc.gridx=0;
		lc.gridy=0;
		lc.anchor=GridBagConstraints.WEST;
		// System.out.println("1");
		String[] names = new String[customer.size()];
		int v=0;
		while ( v < customer.size())
		{
			names[v]=((Customer) customer.elementAt(v)).getName();
			v++;
		}

		// System.out.println("2");
		nameComboB = new JComboBox(names);
		nameComboB.setName("nameComboB");
		nameComboB.setEditable(false);
		nameComboB.setSelectedIndex(0);
		logInsets = new Insets(5,10,0,0);
		lc.insets = logInsets;
		JLabel nameLabel = new JLabel("Full Name:");
		nameLabel.setName("nameLabel-fullname2");
		logInsets = new Insets(0,0,0,10);
		lc.insets = logInsets;
		lc.fill = GridBagConstraints.NONE;
		lc.anchor = GridBagConstraints.EAST;
		logBag.setConstraints(nameLabel,lc);
		logFrame2.getContentPane().add(nameLabel);

		logInsets = new Insets(0,0,0,10);
		lc.insets = logInsets;
		lc.gridx=1;
		lc.anchor = GridBagConstraints.WEST;
		lc.gridwidth=1;
		lc.fill = GridBagConstraints.HORIZONTAL;
		logBag.setConstraints(nameComboB,lc);
		logFrame2.getContentPane().add(nameComboB);
		JLabel passLabel = new JLabel("Password:");
		passLabel.setName(".passLabel-classicslogon");
		lc.gridx=0;
		lc.gridy=1;
		lc.gridwidth=1;
		logInsets = new Insets(0,0,0,10);
		lc.insets = logInsets;
		lc.fill = GridBagConstraints.NONE;
		lc.anchor = GridBagConstraints.EAST;
		logBag.setConstraints(passLabel,lc);
		logFrame2.getContentPane().add(passLabel);

		JPasswordField passText = new JPasswordField(10);
		passText.setName(".passText-classicslogon");
		lc.gridx=1;
		lc.gridy=1;
		lc.gridwidth=1;
		logInsets = new Insets(0,0,0,10);
		lc.insets = logInsets;
		lc.anchor = GridBagConstraints.WEST;
		lc.fill = GridBagConstraints.HORIZONTAL;
		logBag.setConstraints(passText,lc);
		logFrame2.getContentPane().add(passText);
		//	JPasswordField passText = new JPasswordField(10);
		//	lc.gridwidth=GridBagConstraints.REMAINDER;
		//	lc.gridwidth=1;
		//	lc.gridx=1;
		//	logBag.setConstraints(passText,lc);
		//	logFrame2.getContentPane().add(passText);
	
		JCheckBox check = new JCheckBox("Remember Password");
		check.setName("check-rememberpassword2");
		lc.gridy=2;
		logBag.setConstraints(check,lc);
		logFrame2.getContentPane().add(check);

		JButton ok = new JButton("  OK  ");
		ok.setName("ok-statuslogon2");
		ActionListener orderStatusLogListener = new OrderStatusLogListener();
		ok.addActionListener(orderStatusLogListener);

		JButton cancel = new JButton("Cancel");
		cancel.setName("cancel-statuslogon2");
		ActionListener closer = new Closer();
		cancel.setActionCommand("logFrame2");
		cancel.addActionListener(closer);

		lc.gridy=3;
		lc.gridx=0;
		lc.anchor=GridBagConstraints.EAST;
		logInsets = new Insets(20,25,0,5);
		lc.insets = logInsets;
		lc.gridwidth=1;
		logBag.setConstraints(ok,lc);
		logFrame2.getContentPane().add(ok);
		logInsets = new Insets(20,5,0,10);
		lc.insets = logInsets;
		lc.gridx=1;
		lc.anchor=GridBagConstraints.WEST;
		logBag.setConstraints(cancel,lc);
		logFrame2.getContentPane().add(cancel);

		logFrame2.show();

	}
	public static JScrollPane PopulateTree (Vector some)
	{

	ClassicsJava cj = new ClassicsJava();
	//First get distinct composers from recordset for first tier of tree
	int i= 0;
	String uniqueComposers[] = new String[50];
	boolean unique;
	int numUniques = 0;
	while (i < some.size())
		{
		unique=false;
		if (i==0)
		{
			uniqueComposers[i]=((Product) some.elementAt(i)).getComposer();
			//// System.out.println(uniqueComposers[i]);
			numUniques++;
		}
		else
		{
		int j=0;

		while (uniqueComposers[j] != null)
			{

			if (!uniqueComposers[j].equals(((Product) some.elementAt(i)).getComposer()))
				{unique=true;
				//System.out.println("unique: "+ j+ uniqueComposers[j] +" : " + i + some[i].getComposer());
				}
			else	{unique=false;
				//System.out.println("false");
				//System.out.println("j="+j+" "+"i="+i);
				break;
				}
			j++;
			}


			if (unique)
				{
				uniqueComposers[numUniques]=((Product) some.elementAt(i)).getComposer();
				//System.out.println("unique["+i+"] ="+uniqueComposers[i]);
				numUniques++;
				}
		}
		i++;
		}
	int k=0;
	//System.out.println("here they are");
	DefaultMutableTreeNode root = new DefaultMutableTreeNode ("Composers");
	DefaultMutableTreeNode[] composers = new DefaultMutableTreeNode[5];
	while (uniqueComposers[k] !=null)
			{

			composers[k] = new DefaultMutableTreeNode(uniqueComposers[k]);
			int count = 0;
			DefaultMutableTreeNode[] compositions = new DefaultMutableTreeNode[3];
			while (count < some.size())
				{
				//System.out.println("k="+k+" count="+count);
				int numCompositions = 0;
				if (((Product) some.elementAt(count)).getComposer().equals(uniqueComposers[k]))
					{
					//System.out.println(uniqueComposers[k]);
					compositions[numCompositions] = new DefaultMutableTreeNode(((Product) some.elementAt(count)).getComposition());
					composers[k].add(compositions[numCompositions]);
					numCompositions++;
					}

				count++;
				}

			root.add(composers[k]);
			//System.out.println(uniqueComposers[k]+"\n");
			k++;
			}
	cont.remove(splashLabel);
	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	cont.setLayout (gridbag);
	Insets inset = new Insets (10,16,0,0);
	Font largeFont = new Font("SansSerif",Font.BOLD,16);

	inset = new Insets (10,20,5,20);
	c.insets = inset;
	c.anchor=GridBagConstraints.CENTER;
	c.fill = GridBagConstraints.BOTH;

	c.gridx = 1;
	c.gridy = 1;
	c.weightx = 70;
	c.gridwidth= GridBagConstraints.REMAINDER;
	JTree tree = new JTree(root);
	tree.setName("tree2");
	TreeSelectionListener listener = cj.new MyTreeSelectionListener();
	tree.addTreeSelectionListener (listener);
	JScrollPane sp = new JScrollPane();
	sp.setName("sp");
		
		
	tree.setVisibleRowCount(6);
	// System.out.println("count = "+ tree.getVisibleRowCount());
	sp.getViewport().add(tree);
	Dimension spd = new Dimension(400,100);
	sp.setMinimumSize(spd);
	gridbag.setConstraints (sp,c);
	cont.add(sp);

	c.gridy=1;
	tabbedPane = new JTabbedPane();
	tabbedPane.setName("tabbedPane");
	JPanel panel2 = new JPanel();
	panel2.setName("panel2");
	panel2.setOpaque(true);
	// System.out.println("1");
	panel2.setLayout (gridbag);
	c.weighty =0;
	c.weightx = 0;
	c.gridy = 0;
	inset = new Insets (10,0,2,0);
	c.insets = inset;

	// System.out.println("2");
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.gridheight = 1;
	composerLabel = new JLabel (((Product)prodVector.elementAt(0)).getComposer());
	composerLabel.setName("composerLabel");
	composerLabel.setFont(largeFont);
	// System.out.println("2");
	c.anchor=GridBagConstraints.SOUTHWEST;
	gridbag.setConstraints	(composerLabel,c);
	// System.out.println("3");
	panel2.add(composerLabel);

	compositionLabel = new JLabel (((Product)prodVector.elementAt(0)).getComposition());
	compositionLabel.setName("compositionLabel");
	// System.out.println("4");
	c.gridy=1;
	inset = new Insets (5,0,2,0);
	c.insets = inset;

	gridbag.setConstraints(compositionLabel,c);
	panel2.add(compositionLabel);

	if (!prodVector.isEmpty()) {
		imageLabel = new JLabel(((Product) prodVector.elementAt(0)).getAlbumImage());
	}
	
	c.weighty = 4.0;
	c.anchor=GridBagConstraints.CENTER;
	c.gridheight = 20;
	c.gridy=2;
	c.fill = GridBagConstraints.BOTH;
	gridbag.setConstraints	(imageLabel,c);

	panel2.add(imageLabel);
	Font regular = new Font("SansSerif",Font.PLAIN,14);
	Font bold = new Font("SansSerif",Font.BOLD,12);
	JPanel panel2a = new JPanel();
	panel2a.setName("panel2a");
	GridBagLayout detailsBag = new GridBagLayout();
	GridBagConstraints d = new GridBagConstraints();
	panel2a.setOpaque(true);
	panel2a.setLayout(detailsBag);
	Insets detailInset = new Insets (10,0,0,0);
	d.insets=detailInset;
	d.gridx=0;
	d.gridy=0;
	d.anchor=GridBagConstraints.WEST;
	detComposera = new JLabel("Composer:");
	detComposera.setName("detComposera");
	detComposera.setFont(regular);
	detailsBag.setConstraints(detComposera,d);
	panel2a.add(detComposera);
	d.gridx=1;
	d.gridwidth=2; //GridBagConstraints.REMAINDER;
	detailInset = new Insets (10,0,0,0);
	d.insets = detailInset;
	d.fill=GridBagConstraints.HORIZONTAL;
	detComposerb = new JLabel(((Product)prodVector.elementAt(0)).getComposer());
	detComposerb.setName("detComposerb");
	selectedProduct.setComposer(((Product)prodVector.elementAt(0)).getComposer());
	Font midBold = new Font ("SansSarif",Font.BOLD,14);
	detComposerb.setFont(midBold);
	detailsBag.setConstraints(detComposerb,d);
	panel2a.add(detComposerb);

	d.gridx=0;
	d.gridy=1;
	d.gridheight=1;
	d.gridwidth=1;
	detailInset = new Insets (6,0,0,0);
	d.insets = detailInset;
	detCompositiona= new JLabel("Composition:");
	detCompositiona.setName("detCompositiona");
	detCompositiona.setFont(regular);
	detailsBag.setConstraints(detCompositiona,d);
	panel2a.add(detCompositiona);

	d.gridx=1;
	d.gridy=1;
	detCompositionb= new JLabel(((Product)prodVector.elementAt(0)).getComposition());
	detCompositionb.setName("detCompositionb");
	selectedProduct.setComposition(((Product)prodVector.elementAt(0)).getComposition());

	detCompositionb.setFont(bold);
	detailsBag.setConstraints(detCompositionb,d);
	panel2a.add(detCompositionb);


	d.gridx=0;
	d.gridy=2;
	detConductora= new JLabel("Conductor:");
  detConductora.setName("detConductora");
	detConductora.setFont(regular);
	detailsBag.setConstraints(detConductora,d);
	panel2a.add(detConductora);

	d.gridx=1;
	d.gridy=2;
	detConductorb= new JLabel(((Product)prodVector.elementAt(0)).getConductor());
	detConductorb.setName("detConductora");
	detConductorb.setFont(bold);
	detailsBag.setConstraints(detConductorb,d);
	panel2a.add(detConductorb);

	d.gridx=0;
	d.gridy=3;
	detOrchestraa= new JLabel("Orchestra:");
	detOrchestraa.setName("detOrchestraa");	
	detOrchestraa.setFont(regular);
	detailsBag.setConstraints(detOrchestraa,d);
	panel2a.add(detOrchestraa);

	d.gridx=1;
	d.gridy=3;
	detOrchestrab= new JLabel(((Product)prodVector.elementAt(0)).getPerformer());
	detOrchestrab.setName("detOrchestraa");
	detOrchestrab.setFont(bold);
	detailsBag.setConstraints(detOrchestrab,d);
	panel2a.add(detOrchestrab);

	d.gridx=0;
	d.gridy=4;
	detPricea= new JLabel("Price:    ");
	detPricea.setName("detPricea");
	detPricea.setFont(regular);
	detailsBag.setConstraints(detPricea,d);
	panel2a.add(detPricea);

	d.gridx=1;
	d.gridy=4;
	detPriceb= new JLabel("$"+((Product)prodVector.elementAt(0)).getPrice());
	detPriceb.setName("detPriceb");
	selectedProduct.setPrice(((Product)prodVector.elementAt(0)).getPrice());

	detPriceb.setFont(bold);
	detailsBag.setConstraints(detPriceb,d);
	panel2a.add(detPriceb);

	d.gridx=0;
	d.gridy=5;
	d.gridwidth=GridBagConstraints.REMAINDER;
	JLabel detDescriptiona= new JLabel("Description:    ");
	detDescriptiona.setName("detDescriptiona");
	detDescriptiona.setFont(regular);
	detailsBag.setConstraints(detDescriptiona,d);
	panel2a.add(detDescriptiona);

	d.gridy=6;
	d.gridwidth=GridBagConstraints.REMAINDER;
	d.fill=GridBagConstraints.BOTH;
	detDescriptionb = new JTextArea(((Product)prodVector.elementAt(0)).getDescription(),5,20);
	detDescriptionb.setName("detDescriptiona");
	detDescriptionb.setLineWrap(true);
	JScrollPane sp2 = new JScrollPane();
	sp2.setName("sp2-1");
	sp2.getViewport().add(detDescriptionb);
	detailsBag.setConstraints(sp2,d);
	panel2a.add(sp2);



	inset = new Insets (0,10,2,10);
	c.insets = inset;
	c.gridy=0;
	c.gridx=0;
	c.gridwidth=1;
	c.weightx = 30;
	Dimension tpd = new Dimension (50,400);
	tabbedPane.setMaximumSize(tpd);
	c.anchor = GridBagConstraints.WEST;
	tabbedPane.addTab("Album", null, panel2, "");
	tabbedPane.addTab("Details", null, panel2a, "");
	gridbag.setConstraints (tabbedPane,c);	
	cont.add(tabbedPane);


	c.insets = inset;
	c.gridx=1;
	c.weighty=0;
	c.fill= GridBagConstraints.NONE;
	placeOrderButton = new JButton("Place Order");
	placeOrderButton.setName("placeOrderButton2");
	ActionListener orderListener = cj.new OrderActionListener();
	placeOrderButton.addActionListener(orderListener);
	placeOrderButton.setFont(largeFont);
	Dimension dd = new Dimension(30,10);
	//placeOrderButton.setPreferredSize(dd);
	gridbag.setConstraints(placeOrderButton,c);
	cont.add(placeOrderButton);
	placeOrderButton.setEnabled(true);
	placeOrderButton.setActionCommand("Place An Order");

	return sp;
	}

public void setTotalLabel()
	{
	float totalPriceValue;
	try {
		int a = Integer.parseInt(quantityField.getText());
		float b = Float.valueOf(selectedProduct.getPrice()).floatValue();
		totalPriceValue=(a*b+1);
		String rawTotal = Float.toString(totalPriceValue);
		//trim or pad the total as required
		int i = rawTotal.lastIndexOf(".");
		i = i+3; // index of "." plus two digits
		if (i < rawTotal.length()) {
			rawTotal = rawTotal.substring(0, i + 3);
		}
		else if (i > rawTotal.length()) {
			for (int j=rawTotal.length(); j < i; j++) 
				rawTotal = rawTotal + "0";
		}
		totalPrice.setText("$"+ rawTotal);
		}
	catch (Exception e)
		{
		quantityField.setText("");
		totalPrice.setText("$0");
		// System.out.println("Bad number in quantity field");
		}
	}
//	public void start ()
//	{


	//}
}