package com.rational.cdshop.ejb;

import java.util.Properties;
import java.io.Serializable;
import java.util.Enumeration;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.ejb.DuplicateKeyException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.NoSuchEntityException;
import javax.ejb.ObjectNotFoundException;
import javax.ejb.RemoveException;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

/**
 * This is an Entity Bean class with CMP fields
 */
public class CustomerBean implements EntityBean {
	public String address;
	public String city;
	public String credit_card_number;
	public int customer_dbid;
	public String customer_id;
	public String email;
	private javax.ejb.EntityContext entityContext = null;
	public String first_name;
	public String last_name;
	public String password;
	final static long serialVersionUID = 3206093459760846163L;
	public String state;
	public String zip;
	private transient boolean       isDirty;   

/**
 * ejbActivate method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbActivate() throws java.rmi.RemoteException {
}
/**
 * ejbCreate method for a CMP entity bean
 * @param argCustomer_dbid int
 * @exception javax.ejb.CreateException The exception description.
 * @exception java.rmi.RemoteException The exception description.
 */
public com.rational.cdshop.ejb.CustomerKey ejbCreate(int argCustomer_dbid) throws javax.ejb.CreateException, java.rmi.RemoteException {
	// All CMP fields should be initialized here.
	customer_dbid = argCustomer_dbid;
	return null;
}
/**
 * ejbLoad method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbLoad() throws java.rmi.RemoteException {
}
/**
 * ejbPassivate method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbPassivate() throws java.rmi.RemoteException {}
/**
 * ejbPostCreate method for a CMP entity bean
 * @param argCustomer_dbid int
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbPostCreate(int argCustomer_dbid) throws java.rmi.RemoteException {}
/**
 * ejbRemove method comment
 * @exception java.rmi.RemoteException The exception description.
 * @exception javax.ejb.RemoveException The exception description.
 */
public void ejbRemove() throws java.rmi.RemoteException, javax.ejb.RemoveException {
}
/**
 * ejbStore method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbStore() throws java.rmi.RemoteException {}
/**
 * Getter method for address
 * @return java.lang.String
 */
public java.lang.String getAddress() {
	return address;
}
/**
 * Getter method for city
 * @return java.lang.String
 */
public java.lang.String getCity() {
	return city;
}
/**
 * Getter method for credit_card_number
 * @return java.lang.String
 */
public java.lang.String getCredit_card_number() {
	return credit_card_number;
}
/**
 * Getter method for customer_id
 * @return java.lang.String
 */
public java.lang.String getCustomer_id() {
	return customer_id;
}
/**
 * Getter method for email
 * @return java.lang.String
 */
public java.lang.String getEmail() {
	return email;
}
/**
 * getEntityContext method comment
 * @return javax.ejb.EntityContext
 */
public javax.ejb.EntityContext getEntityContext() {
	return entityContext;
}
/**
 * Getter method for first_name
 * @return java.lang.String
 */
public java.lang.String getFirst_name() {
	return first_name;
}
/**
 * Getter method for last_name
 * @return java.lang.String
 */
public java.lang.String getLast_name() {
	return last_name;
}
/**
 * Getter method for password
 * @return java.lang.String
 */
public java.lang.String getPassword() {
	return password;
}
/**
 * Getter method for state
 * @return java.lang.String
 */
public java.lang.String getState() {
	return state;
}
/**
 * Getter method for zip
 * @return java.lang.String
 */
public java.lang.String getZip() {
	return zip;
}
/**
 * Setter method for address
 * @param newValue java.lang.String
 */
public void setAddress(java.lang.String newValue) {
	this.address = newValue;
}
/**
 * Setter method for city
 * @param newValue java.lang.String
 */
public void setCity(java.lang.String newValue) {
	this.city = newValue;
}
/**
 * Setter method for credit_card_number
 * @param newValue java.lang.String
 */
public void setCredit_card_number(java.lang.String newValue) {
	this.credit_card_number = newValue;
}
/**
 * Setter method for customer_id
 * @param newValue java.lang.String
 */
public void setCustomer_id(java.lang.String newValue) {
	this.customer_id = newValue;
}
/**
 * Setter method for email
 * @param newValue java.lang.String
 */
public void setEmail(java.lang.String newValue) {
	this.email = newValue;
}
/**
 * setEntityContext method comment
 * @param ctx javax.ejb.EntityContext
 * @exception java.rmi.RemoteException The exception description.
 */
public void setEntityContext(javax.ejb.EntityContext ctx) throws java.rmi.RemoteException {
	entityContext = ctx;
}
/**
 * Setter method for first_name
 * @param newValue java.lang.String
 */
public void setFirst_name(java.lang.String newValue) {
	this.first_name = newValue;
}
/**
 * Setter method for last_name
 * @param newValue java.lang.String
 */
public void setLast_name(java.lang.String newValue) {
	this.last_name = newValue;
}
/**
 * Setter method for password
 * @param newValue java.lang.String
 */
public void setPassword(java.lang.String newValue) {
	this.password = newValue;
}
/**
 * Setter method for state
 * @param newValue java.lang.String
 */
public void setState(java.lang.String newValue) {
	this.state = newValue;
}
/**
 * Setter method for zip
 * @param newValue java.lang.String
 */
public void setZip(java.lang.String newValue) {
	this.zip = newValue;
}
/**
 * unsetEntityContext method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void unsetEntityContext() throws java.rmi.RemoteException {
	entityContext = null;
}


/**
 * Insert the method's description here.
 * Creation date: (05/04/01 13:32:25)
 */
public CustomerBean() {}


  /** 
   * Returns whether the EJBean has been modified or not.
   *
   * This method must be public for the container to be able to invoke it.
   * 
   * @return                  boolean isDirty
   */
  public boolean isModified() {
    return isDirty;
  }

  /**
   * Sets the EJBean's modified flag.
   * 
   * @param flag              Modified Flag
   */
  public void setModified(boolean flag) {
    isDirty = flag;
  }


}
