package com.rational.cdshop.ejb;

/**
 * This is a Home interface for the Entity Bean
 */
public interface CustomerHome extends javax.ejb.EJBHome {

/**
 * create method for a CMP entity bean
 * @return com.rational.cdshop.ejb.Customer
 * @param argCustomer_dbid int
 * @exception javax.ejb.CreateException The exception description.
 * @exception java.rmi.RemoteException The exception description.
 */
com.rational.cdshop.ejb.Customer create(int argCustomer_dbid) throws javax.ejb.CreateException, java.rmi.RemoteException;
/**
 * Insert the method's description here.
 * Creation date: (3/6/2001 10:11:31 PM)
 * @return com.rational.cdshop.ejb.Customer
 * @param customerId java.lang.String
 * @exception java.rmi.RemoteException The exception description.
 * @exception javax.ejb.FinderException The exception description.
 */
com.rational.cdshop.ejb.Customer findByCustomerId(String customerId) throws java.rmi.RemoteException, javax.ejb.FinderException;
/**
 * findByPrimaryKey method comment
 * @return com.rational.cdshop.ejb.Customer
 * @param key com.rational.cdshop.ejb.CustomerKey
 * @exception java.rmi.RemoteException The exception description.
 * @exception javax.ejb.FinderException The exception description.
 */
com.rational.cdshop.ejb.Customer findByPrimaryKey(com.rational.cdshop.ejb.CustomerKey key) throws java.rmi.RemoteException, javax.ejb.FinderException;
}
