package com.rational.cdshop.ejb;

import java.rmi.RemoteException;
// import java.security.Identity;
import java.util.Properties;
import javax.ejb.*;

/**
 * This is an Entity Bean class with CMP fields
 */
public class TaxBean implements EntityBean {
	public int code;
	public String description;
	private javax.ejb.EntityContext entityContext = null;
	public double rate;
	final static long serialVersionUID = 3206093459760846163L;
	public int tax_dbid;
	boolean isDirty;

/**
 * ejbActivate method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbActivate() throws java.rmi.RemoteException {
}
/**
 * ejbCreate method for a CMP entity bean
 * @param argTax_dbid int
 * @exception javax.ejb.CreateException The exception description.
 * @exception java.rmi.RemoteException The exception description.
 */
public com.rational.cdshop.ejb.TaxKey ejbCreate(int argTax_dbid) throws javax.ejb.CreateException, java.rmi.RemoteException {
	// All CMP fields should be initialized here.
	tax_dbid = argTax_dbid;
	return null;
}
/**
 * ejbLoad method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbLoad() throws java.rmi.RemoteException {
}
/**
 * ejbPassivate method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbPassivate() throws java.rmi.RemoteException {}
/**
 * ejbPostCreate method for a CMP entity bean
 * @param argTax_dbid int
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbPostCreate(int argTax_dbid) throws java.rmi.RemoteException {}
/**
 * ejbRemove method comment
 * @exception java.rmi.RemoteException The exception description.
 * @exception javax.ejb.RemoveException The exception description.
 */
public void ejbRemove() throws java.rmi.RemoteException, javax.ejb.RemoveException {

}
/**
 * ejbStore method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbStore() throws java.rmi.RemoteException {}
/**
 * Getter method for code
 */
public int getCode() {
	return code;
}
/**
 * Getter method for description
 * @return java.lang.String
 */
public java.lang.String getDescription() {
	return description;
}
/**
 * getEntityContext method comment
 * @return javax.ejb.EntityContext
 */
public javax.ejb.EntityContext getEntityContext() {
	return entityContext;
}
/**
 * Getter method for rate
 * @return double
 */
public double getRate() {
	return rate;
}
/**
 * Setter method for code
 */
public void setCode(int newValue) {
	this.code = newValue;
}
/**
 * Setter method for description
 * @param newValue java.lang.String
 */
public void setDescription(java.lang.String newValue) {
	this.description = newValue;
}
/**
 * setEntityContext method comment
 * @param ctx javax.ejb.EntityContext
 * @exception java.rmi.RemoteException The exception description.
 */
public void setEntityContext(javax.ejb.EntityContext ctx) throws java.rmi.RemoteException {
	entityContext = ctx;
}
/**
 * Setter method for rate
 * @param newValue double
 */
public void setRate(double newValue) {
	this.rate = newValue;
}
/**
 * unsetEntityContext method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void unsetEntityContext() throws java.rmi.RemoteException {
	entityContext = null;
}



/**
 * Insert the method's description here.
 * Creation date: (05/04/01 13:32:25)
 */
public TaxBean() {}


  /** 
   * Returns whether the EJBean has been modified or not.
   *
   * This method must be public for the container to be able to invoke it.
   * 
   * @return                  boolean isDirty
   */
  public boolean isModified() {
    return isDirty;
  }

  /**
   * Sets the EJBean's modified flag.
   * 
   * @param flag              Modified Flag
   */
  public void setModified(boolean flag) {
    isDirty = flag;
  }


}