VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CustomerManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3832005B03DE"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"Manager"
Option Explicit

'##ModelId=3841B8ED0341
Implements IUser

'##ModelId=384079C2011F
Implements IMaintADO

'##ModelId=384079BE0232
Implements IViewADO

'##ModelId=38A0560A0221
Public Function IUser_verifyLogin(ByVal customerID As String, ByVal password As String) As Integer
    On Error GoTo IUser_verifyLoginErr

        Dim theCustomerFetcher As DataServices.CustomerFetcher
        Set theCustomerFetcher = CreateObject("DataServices.CustomerFetcher")
        IUser_verifyLogin = theCustomerFetcher.verifyUser(customerID, password)

    Exit Function
IUser_verifyLoginErr:
    Call RaiseError(MyUnhandledError, "IUser_verifyLogin Function")
End Function

Public Function IUser_getPaymentInfo(ByVal customerID As Integer) As Recordset
    On Error GoTo IUser_getPaymentInfoErr

        Dim theCustomerFetcher As DataServices.CustomerFetcher
        Set theCustomerFetcher = CreateObject("DataServices.CustomerFetcher")
        Set IUser_getPaymentInfo = theCustomerFetcher.getPaymentInfo(customerID)

    Exit Function
IUser_getPaymentInfoErr:
    Call RaiseError(MyUnhandledError, "IUser_getPaymentInfo Function")
End Function
Public Function IUser_SaveCustomer(ByVal username As String, _
                ByVal password As String, _
                ByVal firstname As String, _
                ByVal lastname As String, _
                ByVal email As String, _
                ByVal address As String, _
                ByVal city As String, _
                ByVal state As String, _
                ByVal zip As String, _
                ByVal country As String, _
                ByVal cctype As String, _
                ByVal ccnumber As String) As Integer
    On Error GoTo IUser_saveCustomerErr

        Dim theCustomerModifier As DataServices.CustomerModifier
        Set theCustomerModifier = CreateObject("DataServices.CustomerModifier")
        IUser_SaveCustomer = theCustomerModifier.saveCust(username, password, firstname, lastname, email, address, city, state, zip, country, cctype, ccnumber)
    Exit Function
IUser_saveCustomerErr:
    Call RaiseError(MyUnhandledError, "IUser_saveCustomer Subroutine")
End Function



'##ModelId=38A0560A0180
Private Function IUser_getPermissions(username As String) As Recordset
    On Error GoTo IUser_getPermissionsErr

    '## Your code goes here ...

    Exit Function
IUser_getPermissionsErr:
    Call RaiseError(MyUnhandledError, "IUser_getPermissions Function")
End Function

'##ModelId=3841BEA7032B
Public Function GetPassword(intID As Integer) As String
    On Error GoTo GetPasswordErr

    '## Your code goes here ...

    Exit Function
GetPasswordErr:
    Call RaiseError(MyUnhandledError, "GetPassword Function")
End Function

'##ModelId=3841BF190357
Public Function GetEmptyRecordset() As Recordset
    On Error GoTo GetEmptyRecordsetErr

    '## Your code goes here ...

    Exit Function
GetEmptyRecordsetErr:
    Call RaiseError(MyUnhandledError, "GetEmptyRecordset Function")
End Function

    '##ModelId=384EF5AF03D0
Public Function GetCustomerByID(intID As Integer) As Recordset
    On Error GoTo GetCustomerByIDErr

    '## Your code goes here ...

    Exit Function
GetCustomerByIDErr:
    Call RaiseError(MyUnhandledError, "GetCustomerByID Function")
End Function

'##ModelId=384EF60B01CA
Public Function GetCustomerList(strPattern As String) As Recordset
    On Error GoTo GetCustomerListErr

    '## Your code goes here ...

    Exit Function
GetCustomerListErr:
    Call RaiseError(MyUnhandledError, "GetCustomerList Function")
End Function

'##ModelId=384EF6A40379
Public Function SaveCustomer(ByVal username As String, _
                ByVal password As String, _
                ByVal firstname As String, _
                ByVal lastname As String, _
                ByVal email As String, _
                ByVal address As String, _
                ByVal city As String, _
                ByVal state As String, _
                ByVal zip As String, _
                ByVal country As String, _
                ByVal cctype As String, _
                ByVal ccnumber As String) As Integer
    On Error GoTo SaveCustomerErr


    '## Your code goes here ...

     Exit Function
SaveCustomerErr:
    Call RaiseError(MyUnhandledError, "SaveCustomer Sub")
End Function

'ID is customer ID.
'##ModelId=384EF6D302FE
Public Sub DeleteCustomer(intID As Integer)
    On Error GoTo DeleteCustomerErr

    '## Your code goes here ...

    Exit Sub
DeleteCustomerErr:
    Call RaiseError(MyUnhandledError, "DeleteCustomer Sub")
End Sub

'##ModelId=38A056090324
Private Function IViewADO_GetList() As Recordset
    On Error GoTo IViewADO_GetListErr

    '## Your code goes here ...

    Exit Function
IViewADO_GetListErr:
    Call RaiseError(MyUnhandledError, "IViewADO_GetList Function")
End Function

'##ModelId=38A05609034C
Private Function IViewADO_GetByID(intCD_DBID As Integer) As Recordset
    On Error GoTo IViewADO_GetByIDErr

    '## Your code goes here ...

    Exit Function
IViewADO_GetByIDErr:
    Call RaiseError(MyUnhandledError, "IViewADO_GetByID Function")
End Function

'##ModelId=38A05609039C
Private Function IViewADO_Search(strCDSearchString As String, intCDSearchCriteria As Integer) As Recordset
    On Error GoTo IViewADO_SearchErr

    '## Your code goes here ...

    Exit Function
IViewADO_SearchErr:
    Call RaiseError(MyUnhandledError, "IViewADO_Search Function")
End Function

'##ModelId=38A0560A004A
Private Sub IMaintADO_Save(rs As Recordset)
    On Error GoTo IMaintADO_SaveErr

    '## Your code goes here ...

    Exit Sub
IMaintADO_SaveErr:
    Call RaiseError(MyUnhandledError, "IMaintADO_save Sub")
End Sub

'##ModelId=38A0560A00A4
Private Sub IMaintADO_Delete(intID As Integer)
    On Error GoTo IMaintADO_DeleteErr

    '## Your code goes here ...

    Exit Sub
IMaintADO_DeleteErr:
    Call RaiseError(MyUnhandledError, "IMaintADO_delete Sub")
End Sub

'##ModelId=38A0560A0108
Private Property Get IMaintADO_ClassDebugID() As Variant
    On Error GoTo IMaintADO_ClassDebugIDErr

    '## Your code goes here ...

    Exit Property
IMaintADO_ClassDebugIDErr:
    Call RaiseError(MyUnhandledError, "IMaintADO_ClassDebugID Property")
End Property
