/*
      ->-> Session File Information <-<-
       Created: Wed Dec 22 07:28:17 1999
          Name: Order.wch
          Type: PerformanceStudio-API
                (with Wininet HTTP)
                (with Winsock1 Data)
*/

#include <VU.h>
{
string webserver = "";
/* Specifies the name of the webserver.                     */
/* This comes from an environment variable in the schedule  */
/* If not specified, then defaults to localhost             */
webserver = getenv("WebServer");
if (webserver == "")
    webserver = "localhost:80";
    
push Http_control = HTTP_PARTIAL_OK | HTTP_CACHE_OK | HTTP_REDIRECT_OK;

{  /* Persistent variables needed by other scripts */
     persistent int D1dy6j_1;
     persistent int D1dy6j_3;
     persistent int D1dy6j_4;
}


{
     persistent int Min_tmout;
}

push Timeout_scale = 200; /* Set timeouts to 200% of maximum response time */
push Think_max = 2000;  /* Set maximum think time between commands */
push Think_def = "LR";
Min_tmout = 120000;       /* Set minimum Timeout_val to 2 minutes          */
push Timeout_val = Min_tmout;
push Think_cpu_threshold = 500;

DP1 = datapool_open("SearchCD");
datapool_fetch(DP1);

push Think_avg = 0;             /* 0 < 500 (cpu processing delay) */

D1dy6j = http_request ["HTTP1.001"] "" + webserver +"",
        HTTP_CONN_DIRECT,
   "GET /cdshop/ HTTP/1.1\r\n"
   "Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, applicatio"
   "n/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, */*\r"
   "\n"
   "Accept-Language: en-us\r\n"
   "Accept-Encoding: gzip, deflate\r\n"
   "User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)\r\n"
   "Host: " + webserver +"\r\n"
   "Connection: Keep-Alive\r\n"
   "\r\n";

set Server_connection = D1dy6j;

http_header_recv ["HTTP1.002"]  200;    /* OK */

#if 0
    "HTTP/1.1 200 ok\r\n"
    "Date: Wed, 22 Dec 1999 15:33:46 GMT\r\n"
    "Server: IBM_HTTP_Server/1.3.6 Apache/1.3.7-dev (Win32)\r\n"
    "last-modified: Mon, 20 Dec 1999 20:30:20 GMT\r\n"
    "Keep-Alive: timeout=15, max=100\r\n"
    "Connection: Keep-Alive\r\n"
    "Transfer-Encoding: chunked\r\n"
    "Content-Type: text/html\r\n"
    "\r\n"
#endif

http_nrecv ["HTTP1.003"]  100 %% ;      /* 1692 bytes */
set Think_avg = 461;            /* 461 < 500 (cpu processing delay) */

 /* Keep-Alive request over connection D1dy6j */
http_request ["HTTP1.004"] 
   "GET /cdshop/images/classicsCDlogo.jpg HTTP/1.1\r\n"
   "Accept: */*\r\n"
   "Referer: http://" + webserver +"/cdshop/\r\n"
   "Accept-Language: en-us\r\n"
   "Accept-Encoding: gzip, deflate\r\n"
   "If-Modified-Since: Thu, 11 Nov 1999 15:19:20 GMT\r\n"
   "User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)\r\n"
   "Host: " + webserver +"\r\n"
   "Connection: Keep-Alive\r\n"
   "\r\n";

http_header_recv ["HTTP1.005"]  304;    /* Not Modified */

http_nrecv ["HTTP1.006"]  100 %% ;      /* From Cache */

http_disconnect(D1dy6j);
set Think_avg = 1843;           /* 1843 >= 500 (user think time delay) */

D1dy6j_1 = http_request ["HTTP1.007"] "" + webserver +"",
        HTTP_CONN_DIRECT,
   "GET /cdshop/cdshop?before="
   +http_url_encode(datapool_value(DP1, "before"))+
   " HTTP/1.1\r\n"
   "Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, applicatio"
   "n/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, */*\r"
   "\n"
   "Referer: http://" + webserver +"/cdshop/\r\n"
   "Accept-Language: en-us\r\n"
   "Accept-Encoding: gzip, deflate\r\n"
   "User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)\r\n"
   "Host: " + webserver +"\r\n"
   "Connection: Keep-Alive\r\n"
   "\r\n";

set Server_connection = D1dy6j_1;

http_header_recv ["HTTP1.008"]  200;    /* OK */

#if 0
    "HTTP/1.1 200 ok\r\n"
    "Date: Wed, 22 Dec 1999 15:33:50 GMT\r\n"
    "Server: IBM_HTTP_Server/1.3.6 Apache/1.3.7-dev (Win32)\r\n"
    "Set-Cookie: sesessionid=HKTT2QAAAAAAHLAVVNE21CQ;Path=/\r\n"
    "Cache-Control: no-cache=\"set-cookie,set-cookie2\"\r\n"
    "Expires: Thu, 01 Dec 1994 16:00:00 GMT\r\n"
    "Keep-Alive: timeout=15, max=100\r\n"
    "Connection: Keep-Alive\r\n"
    "Transfer-Encoding: chunked\r\n"
    "Content-Type: text/html\r\n"
    "\r\n"
#endif

http_nrecv ["HTTP1.009"]  100 %% ;      /* 1185 bytes */
set Think_avg = 361;            /* 361 < 500 (cpu processing delay) */

D1dy6j_2 = http_request ["HTTP1.010"] "" + webserver +"",
        HTTP_CONN_DIRECT,
   "GET /cdshop/images/ClassicsCDsplash.jpg HTTP/1.1\r\n"
   "Accept: */*\r\n"
   "Referer: http://" + webserver +"/cdshop/cdshop?before=no\r\n"
   "Accept-Language: en-us\r\n"
   "Accept-Encoding: gzip, deflate\r\n"
   "User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)\r\n"
   "Host: " + webserver +"\r\n"
   "Connection: Keep-Alive\r\n"
   "Cookie: sesessionid=HKTT2QAAAAAAHLAVVNE21CQ\r\n"
   "\r\n";
set Think_avg = 1562;           /* 1562 >= 500 (user think time delay) */

 /* Keep-Alive request over connection D1dy6j_1 */
http_request ["HTTP1.011"] 
   "GET /cdshop/cdcatalog HTTP/1.1\r\n"
   "Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, applicatio"
   "n/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, */*\r"
   "\n"
   "Referer: http://" + webserver +"/cdshop/cdshop?before=no\r\n"
   "Accept-Language: en-us\r\n"
   "Accept-Encoding: gzip, deflate\r\n"
   "User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)\r\n"
   "Host: " + webserver +"\r\n"
   "Connection: Keep-Alive\r\n"
   "Cookie: sesessionid=HKTT2QAAAAAAHLAVVNE21CQ\r\n"
   "\r\n";

 /* Request for Current Connection */
 /*  Failed with Error Code 12017  */

http_disconnect(D1dy6j_2);

http_header_recv ["HTTP1.012"]  200;    /* OK */

#if 0
    "HTTP/1.1 200 ok\r\n"
    "Date: Wed, 22 Dec 1999 15:33:52 GMT\r\n"
    "Server: IBM_HTTP_Server/1.3.6 Apache/1.3.7-dev (Win32)\r\n"
    "Keep-Alive: timeout=15, max=99\r\n"
    "Connection: Keep-Alive\r\n"
    "Transfer-Encoding: chunked\r\n"
    "Content-Type: text/html\r\n"
    "\r\n"
#endif

http_nrecv ["HTTP1.013"]  3870;

http_nrecv ["HTTP1.014"]  100 %% ;      /* Last 4494 of 8364 bytes */
set Think_avg = 300;            /* 300 < 500 (cpu processing delay) */

D1dy6j_3 = http_request ["HTTP1.015"] "" + webserver +"",
        HTTP_CONN_DIRECT,
   "GET /cdshop/images/ClassicsCDsplash.jpg HTTP/1.1\r\n"
   "Accept: */*\r\n"
   "Referer: http://" + webserver +"/cdshop/cdcatalog\r\n"
   "Accept-Language: en-us\r\n"
   "Accept-Encoding: gzip, deflate\r\n"
   "User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)\r\n"
   "Host: " + webserver +"\r\n"
   "Connection: Keep-Alive\r\n"
   "Cookie: sesessionid=HKTT2QAAAAAAHLAVVNE21CQ\r\n"
   "\r\n";
set Think_avg = 300;            /* 300 < 500 (cpu processing delay) */

D1dy6j_4 = http_request ["HTTP1.016"] "" + webserver +"",
        HTTP_CONN_DIRECT,
   "GET /cdshop/images/shoppingcart.gif HTTP/1.1\r\n"
   "Accept: */*\r\n"
   "Referer: http://" + webserver +"/cdshop/cdcatalog\r\n"
   "Accept-Language: en-us\r\n"
   "Accept-Encoding: gzip, deflate\r\n"
   "User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)\r\n"
   "Host: " + webserver +"\r\n"
   "Connection: Keep-Alive\r\n"
   "Cookie: sesessionid=HKTT2QAAAAAAHLAVVNE21CQ\r\n"
   "\r\n";

set Server_connection = D1dy6j_3;

http_header_recv ["HTTP1.017"]  200;    /* OK */

#if 0
    "HTTP/1.1 200 ok\r\n"
    "Date: Wed, 22 Dec 1999 15:33:53 GMT\r\n"
    "Server: IBM_HTTP_Server/1.3.6 Apache/1.3.7-dev (Win32)\r\n"
    "last-modified: Thu, 04 Nov 1999 17:41:32 GMT\r\n"
    "Keep-Alive: timeout=15, max=100\r\n"
    "Connection: Keep-Alive\r\n"
    "Transfer-Encoding: chunked\r\n"
    "Content-Type: image/jpeg\r\n"
    "\r\n"
#endif

set Server_connection = D1dy6j_4;

http_header_recv ["HTTP1.018"]  200;    /* OK */

#if 0
    "HTTP/1.1 200 ok\r\n"
    "Date: Wed, 22 Dec 1999 15:33:53 GMT\r\n"
    "Server: IBM_HTTP_Server/1.3.6 Apache/1.3.7-dev (Win32)\r\n"
    "last-modified: Sun, 28 Feb 1999 00:50:56 GMT\r\n"
    "Keep-Alive: timeout=15, max=100\r\n"
    "Connection: Keep-Alive\r\n"
    "Transfer-Encoding: chunked\r\n"
    "Content-Type: image/gif\r\n"
    "\r\n"
#endif
set Think_avg = 1732;           /* 1732 >= 500 (user think time delay) */

set Server_connection = D1dy6j_1;

 /* Keep-Alive request over connection D1dy6j_1 */
http_request ["HTTP1.019"] 
   "GET /cdshop/cdcatalog?buy="
   +http_url_encode(datapool_value(DP1, "buy"))+
   " HTTP/1.1\r\n"
   "Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, applicatio"
   "n/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, */*\r"
   "\n"
   "Referer: http://" + webserver +"/cdshop/cdcatalog\r\n"
   "Accept-Language: en-us\r\n"
   "Accept-Encoding: gzip, deflate\r\n"
   "User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)\r\n"
   "Host: " + webserver +"\r\n"
   "Connection: Keep-Alive\r\n"
   "Cookie: sesessionid=HKTT2QAAAAAAHLAVVNE21CQ\r\n"
   "\r\n";

http_header_recv ["HTTP1.020"]  200;    /* OK */

#if 0
    "HTTP/1.1 200 ok\r\n"
    "Date: Wed, 22 Dec 1999 15:33:55 GMT\r\n"
    "Server: IBM_HTTP_Server/1.3.6 Apache/1.3.7-dev (Win32)\r\n"
    "Keep-Alive: timeout=15, max=98\r\n"
    "Connection: Keep-Alive\r\n"
    "Transfer-Encoding: chunked\r\n"
    "Content-Type: text/html\r\n"
    "\r\n"
#endif

http_nrecv ["HTTP1.021"]  8192;

http_nrecv ["HTTP1.022"]  100 %% ;      /* Last 192 of 8384 bytes */

pop Http_control;

}


DATAPOOL_CONFIG "SearchCD"      OVERRIDE DP_NOWRAP DP_SEQUENTIAL DP_SHARED
{
        EXCLUDE, "before", "string", "no";
        EXCLUDE, "buy", "string", "1635170212";
}

