package com.rational.cdshop.ejb;

import java.rmi.RemoteException;
import javax.ejb.EJBObject;

/**
 * This is an Enterprise Java Bean Remote Interface
 */
public interface Cd extends javax.ejb.EJBObject {
/**
 * Getter method for composer
 * @return java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
java.lang.String getComposer() throws java.rmi.RemoteException;
/**
 * Getter method for composition
 * @return java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
java.lang.String getComposition() throws java.rmi.RemoteException;
/**
 * Getter method for conductor
 * @return java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
java.lang.String getConductor() throws java.rmi.RemoteException;
/**
 * Getter method for description
 * @return java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
java.lang.String getDescription() throws java.rmi.RemoteException;
/**
 * Getter method for image
 * @return java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
java.lang.String getImage() throws java.rmi.RemoteException;
/**
 * Getter method for performer
 * @return java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
java.lang.String getPerformer() throws java.rmi.RemoteException;
/**
 * Getter method for price
 * @return double
 * @exception javax.ejb.EJBException The exception description.
 */
double getPrice() throws java.rmi.RemoteException;
/**
 * Getter method for tax_code
 * @return int
 * @exception javax.ejb.EJBException The exception description.
 */
int getTax_code() throws java.rmi.RemoteException;
/**
 * Getter method for upc
 * @return java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
java.lang.String getUpc() throws java.rmi.RemoteException;
/**
 * Setter method for composer
 * @param newValue java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
void setComposer(java.lang.String newValue) throws java.rmi.RemoteException;
/**
 * Setter method for composition
 * @param newValue java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
void setComposition(java.lang.String newValue) throws java.rmi.RemoteException;
/**
 * Setter method for conductor
 * @param newValue java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
void setConductor(java.lang.String newValue) throws java.rmi.RemoteException;
/**
 * Setter method for description
 * @param newValue java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
void setDescription(java.lang.String newValue) throws java.rmi.RemoteException;
/**
 * Setter method for image
 * @param newValue java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
void setImage(java.lang.String newValue) throws java.rmi.RemoteException;
/**
 * Setter method for performer
 * @param newValue java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
void setPerformer(java.lang.String newValue) throws java.rmi.RemoteException;
/**
 * Setter method for price
 * @param newValue double
 * @exception javax.ejb.EJBException The exception description.
 */
void setPrice(double newValue) throws java.rmi.RemoteException;
/**
 * Setter method for tax_code
 * @param newValue int
 * @exception javax.ejb.EJBException The exception description.
 */
void setTax_code(int newValue) throws java.rmi.RemoteException;
/**
 * Setter method for upc
 * @param newValue java.lang.String
 * @exception javax.ejb.EJBException The exception description.
 */
void setUpc(java.lang.String newValue) throws java.rmi.RemoteException;
}